IJAGI = {
	displayName = "Beta |cFF00FF" .. "IsJusta Gamepad Inventory Update" .. "|r",
	name = "IsJustaGamepadInventory-Beta",
	version = "2.0.3",
	svVersion = 2.02,
	
	defaults = {
		useCarriedTab = true,
		cleanRefinementTab = true,
		filterStolen = true,
		stolenCategory = true,
		filterJunk = true,
		junkCategory = true,
		filterMaps = true,
		mapsCategory = true,
	}
}

local addOnName = IJAGI.name
local isTooltipLoop = false
-------------------
-- Settings menu
-------------------
function IJAGI:SetupSettings()
	local LAM2 = LibAddonMenu2
	if not LAM2 then
		return
	end

	local panelData = {
		type = "panel",
		name = self.displayName,
		displayName = self.displayName,
		author = "IsJustaGhost",
		version = "1.0.0",
		registerForRefresh = true,
		registerForDefaults = true
	}
	LAM2:RegisterAddonPanel(self.name, panelData)

	local optionsTable = {
		{
            type = "header",
            name = GetString(SI_ISJGI_CATEGORIES),
            width = "full",
        },
		{
			type = "checkbox",
			name = GetString(SI_ISJGI_CATEGORY_MAPS),
			tooltip = GetString(SI_ISJGI_CATEGORY_TOOLTIP),
			getFunc = function() return self.savedVariables.mapsCategory end,
			setFunc = function(value)
				self.savedVariables.mapsCategory = value
				if value ~= true then self.savedVariables.filterMaps = value end
			end,
			default = self.savedVariables.mapsCategory,
            width = "half"
		},
		{
			type = "checkbox",
			name = GetString(SI_ISJGI_FILTER_Maps),
			tooltip = GetString(SI_ISJGI_FILTER_MAPS_TOOLTIP),
			getFunc = function() return self.savedVariables.filterMaps end,
			setFunc = function(value) self.savedVariables.filterMaps = value end,
			default = self.savedVariables.filterMaps,
            width = "half",
			disabled = function() return not self.savedVariables.mapsCategory end,
		},
		{
			type = "checkbox",
			name = GetString(SI_ISJGI_CATEGORY_JUNK),
			tooltip = GetString(SI_ISJGI_CATEGORY_JUNK_TOOLTIP),
			getFunc = function() return self.savedVariables.junkCategory end,
			setFunc = function(value)
				self.savedVariables.junkCategory = value
				if value ~= true then self.savedVariables.filterJunk = value end
			end,
			default = self.savedVariables.junkCategory,
            width = "half"
		},
		{
			type = "checkbox",
			name = GetString(SI_ISJGI_FILTER_JUNK),
			tooltip = GetString(SI_ISJGI_FILTER_JUNK_TOOLTIP),
			getFunc = function() return self.savedVariables.filterJunk end,
			setFunc = function(value) self.savedVariables.filterJunk = value end,
			default = self.savedVariables.filterJunk,
            width = "half",
			disabled = function() return not self.savedVariables.junkCategory end,
		},
		{
			type = "checkbox",
			name = GetString(SI_ISJGI_CATEGORY_STOLEN),
			tooltip = GetString(SI_ISJGI_CATEGORY_STOLEN_TOOLTIP),
			getFunc = function() return self.savedVariables.stolenCategory end,
			setFunc = function(value)
				self.savedVariables.stolenCategory = value
				if value ~= true then self.savedVariables.filterStolen = value end
			end,
			default = self.savedVariables.stolenCategory,
            width = "half"
		},
		{
			type = "checkbox",
			name = GetString(SI_ISJGI_FILTER_STOLEN),
			tooltip = GetString(SI_ISJGI_FILTER_STOLEN_TOOLTIP),
			getFunc = function() return self.savedVariables.filterStolen end,
			setFunc = function(value) self.savedVariables.filterStolen = value end,
			default = self.savedVariables.filterStolen,
            width = "half",
			disabled = function() return not self.savedVariables.stolenCategory end,
		},
		{
            type = "header",
            name = GetString(SI_IJAGI_SMITHINGS_OPTIONS),
            width = "full",
        },
		{
			type = "checkbox",
			name = GetString(SI_ISJGI_USE_CARRIED_TAB),
			tooltip = GetString(SI_ISJGI_USE_CARRIED_TOOLTIP),
			getFunc = function() return self.savedVariables.useCarriedTab end,
			setFunc = function(value)
				self.savedVariables.useCarriedTab = value
				if value ~= true then self.savedVariables.cleanRefinementTab = value end
			end,
			default = self.savedVariables.useCarriedTab,
            width = "full",
			requiresReload = true
		},
		{
			type = "checkbox",
			name = GetString(SI_ISJGI_USE_CLEAN_REFINMENT_TAB),
			tooltip = GetString(SI_ISJGI_USE_CLEAN_REFINMENT_TOOLTIP),
			getFunc = function() return self.savedVariables.cleanRefinementTab end,
			setFunc = function(value) self.savedVariables.cleanRefinementTab = value end,
			default = self.savedVariables.cleanRefinementTab,
            width = "full",
			disabled = function() return not self.savedVariables.useCarriedTab end,
		}
	}
	LAM2:RegisterOptionControls(self.name, optionsTable)
end

-------------------
local SET_ITEM_LIST = "setList"
local SET_CATEGORY_LIST = "categorySetList"
local SET_CATEGORY_ACTION_MODE = 4
local SET_ITEM_LIST_ACTION_MODE = 5

local INVENTORY_CATEGORY_LIST = "categoryList"
local INVENTORY_ITEM_LIST = "itemList"
local INVENTORY_CRAFT_BAG_LIST = "craftBagList"

local SET_TYPE_MONSTER = 1
local SET_TYPE_MYTHICS = 2
local SET_TYPE_JEWELRY = 3
local SET_TYPE_CRAFTED = 4
local SET_TYPE_DROPPED = 5
local SET_TYPE_TRIAL = 6
local SET_TYPE_ARENA = 7

local subCategoryModes = {
	["Armor"] = 1,
	["Weapons"] = 2,
	["Jewelry"] = 3,
}

local setTypeByName = {	
	["Spawn of Mephala"] = SET_TYPE_MONSTER,
	["Bloodspawn"] = SET_TYPE_MONSTER,
	["Lord Warden"] = SET_TYPE_MONSTER,
	["Scourge Harvester"] = SET_TYPE_MONSTER,
	["Engine Guardian"] = SET_TYPE_MONSTER,
	["Nightflame"] = SET_TYPE_MONSTER,
	["Nerien'eth"] = SET_TYPE_MONSTER,
	["Valkyn Skoria"] = SET_TYPE_MONSTER,
	["Maw of the Infernal"] = SET_TYPE_MONSTER,
	["Molag Kena"] = SET_TYPE_MONSTER,
	["Velidreth"] = SET_TYPE_MONSTER,
	["Mighty Chudan"] = SET_TYPE_MONSTER,
	["Swarm Mother"] = SET_TYPE_MONSTER,
	["Slimecraw"] = SET_TYPE_MONSTER,
	["Tremorscale"] = SET_TYPE_MONSTER,
	["Pirate Skeleton"] = SET_TYPE_MONSTER,
	["Shadowrend"] = SET_TYPE_MONSTER,
	["Sentinel of Rkugamz"] = SET_TYPE_MONSTER,
	["Chokethorn"] = SET_TYPE_MONSTER,
	["Infernal Guardian"] = SET_TYPE_MONSTER,
	["Ilambris"] = SET_TYPE_MONSTER,
	["Iceheart"] = SET_TYPE_MONSTER,
	["The Troll King"] = SET_TYPE_MONSTER,
	["Grothdarr"] = SET_TYPE_MONSTER,
	["Kra'gh"] = SET_TYPE_MONSTER,
	["Sellistrix"] = SET_TYPE_MONSTER,
	["Stormfist"] = SET_TYPE_MONSTER,
	["Selene"] = SET_TYPE_MONSTER,
	["Earthgore"] = SET_TYPE_MONSTER,
	["Domihaus"] = SET_TYPE_MONSTER,
	["Thurvokun"] = SET_TYPE_MONSTER,
	["Zaan"] = SET_TYPE_MONSTER,
	["Balorgh"] = SET_TYPE_MONSTER,
	["Vykosa"] = SET_TYPE_MONSTER,
	["Stonekeeper"] = SET_TYPE_MONSTER,
	["Symphony of Blades"] = SET_TYPE_MONSTER,
	["Grundwulf"] = SET_TYPE_MONSTER,
	["Maarselok"] = SET_TYPE_MONSTER,
	["Mother Ciannait"] = SET_TYPE_MONSTER,
	["Kjalnar's Nightmare"] = SET_TYPE_MONSTER,
	["Stone Husk"] = SET_TYPE_MONSTER,
	["Lady Thorn"] = SET_TYPE_MONSTER,
	
	["Ring of the Wild Hunt"] = SET_TYPE_MYTHICS,
	["Torc of Tonal Constancy"] = SET_TYPE_MYTHICS,
	["Thrassian Stranglers"] = SET_TYPE_MYTHICS,
	["Snow Treaders"] = SET_TYPE_MYTHICS,
	["Malacath's Band of Brutality"] = SET_TYPE_MYTHICS,
	["Bloodlord's Embrace"] = SET_TYPE_MYTHICS,
	
	["Death's Wind"] = SET_TYPE_CRAFTED,
	["Twilight's Embrace"] = SET_TYPE_CRAFTED,
	["Night's Silence"] = SET_TYPE_CRAFTED,
	["Whitestrake's Retribution"] = SET_TYPE_CRAFTED,
	["Armor of the Seducer"] = SET_TYPE_CRAFTED,
	["Vampire's Kiss"] = SET_TYPE_CRAFTED,
	["Magnus' Gift"] = SET_TYPE_CRAFTED,
	["Night Mother's Gaze"] = SET_TYPE_CRAFTED,
	["Ashen Grip"] = SET_TYPE_CRAFTED,
	["Oblivion's Foe"] = SET_TYPE_CRAFTED,
	["Spectre's Eye"] = SET_TYPE_CRAFTED,
	["Torug's Pact"] = SET_TYPE_CRAFTED,
	["Hist Bark"] = SET_TYPE_CRAFTED,
	["Willow's Path"] = SET_TYPE_CRAFTED,
	["Hunding's Rage"] = SET_TYPE_CRAFTED,
	["Song of Lamae"] = SET_TYPE_CRAFTED,
	["Alessia's Bulwark"] = SET_TYPE_CRAFTED,
	["Orgnum's Scales"] = SET_TYPE_CRAFTED,
	["Eyes of Mara"] = SET_TYPE_CRAFTED,
	["Kagrenac's Hope"] = SET_TYPE_CRAFTED,
	["Shalidor's Curse"] = SET_TYPE_CRAFTED,
	["Way of the Arena"] = SET_TYPE_CRAFTED,
	["Twice-Born Star"] = SET_TYPE_CRAFTED,
	["Noble's Conquest"] = SET_TYPE_CRAFTED,
	["Redistributor"] = SET_TYPE_CRAFTED,
	["Armor Master"] = SET_TYPE_CRAFTED,
	["Law of Julianos"] = SET_TYPE_CRAFTED,
	["Trial by Fire"] = SET_TYPE_CRAFTED,
	["Morkuldin"] = SET_TYPE_CRAFTED,
	["Tava's Favor"] = SET_TYPE_CRAFTED,
	["Clever Alchemist"] = SET_TYPE_CRAFTED,
	["Eternal Hunt"] = SET_TYPE_CRAFTED,
	["Kvatch Gladiator"] = SET_TYPE_CRAFTED,
	["Varen's Legacy"] = SET_TYPE_CRAFTED,
	["Pelinal's Aptitude"] = SET_TYPE_CRAFTED,
	["Assassin's Guile"] = SET_TYPE_CRAFTED,
	["Daedric Trickery"] = SET_TYPE_CRAFTED,
	["Shacklebreaker"] = SET_TYPE_CRAFTED,
	["Innate Axiom"] = SET_TYPE_CRAFTED,
	["Fortified Brass"] = SET_TYPE_CRAFTED,
	["Mechanical Acuity"] = SET_TYPE_CRAFTED,
	["Adept Rider"] = SET_TYPE_CRAFTED,
	["Sload's Semblance"] = SET_TYPE_CRAFTED,
	["Nocturnal's Favor"] = SET_TYPE_CRAFTED,
	["Grave-Stake Collector"] = SET_TYPE_CRAFTED,
	["Naga Shaman"] = SET_TYPE_CRAFTED,
	["Might of the Lost Legion"] = SET_TYPE_CRAFTED,
	["Coldharbour's Favorite"] = SET_TYPE_CRAFTED,
	["Senche-raht's Grit"] = SET_TYPE_CRAFTED,
	["Vastarie's Tutelage"] = SET_TYPE_CRAFTED,
	["Daring Corsair"] = SET_TYPE_CRAFTED,
	["Ancient Dragonguard"] = SET_TYPE_CRAFTED,
	["New Moon Acolyte"] = SET_TYPE_CRAFTED,
	["Critical Riposte"] = SET_TYPE_CRAFTED,
	["Unchained Aggressor"] = SET_TYPE_CRAFTED,
	["Dauntless Combatant"] = SET_TYPE_CRAFTED,
	["Stuhn's Favor"] = SET_TYPE_CRAFTED,
	["Dragon's Appetite"] = SET_TYPE_CRAFTED,
	["Spell Parasite"] = SET_TYPE_CRAFTED,
	
	["Endurance"] = SET_TYPE_JEWELRY,
	["Willpower"] = SET_TYPE_JEWELRY,
	["Agility"] = SET_TYPE_JEWELRY,
	["Blessing of the Potentates"] = SET_TYPE_JEWELRY,
	["Wrath of the Imperium"] = SET_TYPE_JEWELRY,
	["Grace of the Ancients"] = SET_TYPE_JEWELRY,
	["Eagle Eye"] = SET_TYPE_JEWELRY,
	["Vengeance Leech"] = SET_TYPE_JEWELRY,
	
	["Aegis of Galenwe"] = SET_TYPE_TRIAL,
	["Arms of Relequen"] = SET_TYPE_TRIAL,
	["Automated Defense"] = SET_TYPE_TRIAL,
	["Berserking Warrior"] = SET_TYPE_TRIAL,
	["Chaotic Whirlwind"] = SET_TYPE_TRIAL,
	["Claw of Yolnahkriin"] = SET_TYPE_TRIAL,
	["Concentrated Force"] = SET_TYPE_TRIAL,
	["Defending Warrior"] = SET_TYPE_TRIAL,
	["Defensive Position"] = SET_TYPE_TRIAL,
	["Destructive Mage"] = SET_TYPE_TRIAL,
	["Disciplined Slash"] = SET_TYPE_TRIAL,
	["Eternal Warrior"] = SET_TYPE_TRIAL,
	["Executioner's Blade"] = SET_TYPE_TRIAL,
	["Explosive Rebuke"] = SET_TYPE_TRIAL,
	["Eye of Nahviintaas"] = SET_TYPE_TRIAL,
	["False God's Devotion"] = SET_TYPE_TRIAL,
	["Force Overflow"] = SET_TYPE_TRIAL,
	["Frenzied Momentum"] = SET_TYPE_TRIAL,
	["Healing Mage"] = SET_TYPE_TRIAL,
	["Hex Siphon"] = SET_TYPE_TRIAL,
	["Immortal Warrior"] = SET_TYPE_TRIAL,
	["Infallible Mage"] = SET_TYPE_TRIAL,
	["Inventor's Guard"] = SET_TYPE_TRIAL,
	["Kyne's Wind"] = SET_TYPE_TRIAL,
	["Lunar Bastion"] = SET_TYPE_TRIAL,
	["Mantle of Siroria"] = SET_TYPE_TRIAL,
	["Master Architect"] = SET_TYPE_TRIAL,
	["Moondancer"] = SET_TYPE_TRIAL,
	["Perfect Aegis of Galenwe"] = SET_TYPE_TRIAL,
	["Perfect Arms of Relequen"] = SET_TYPE_TRIAL,
	["Perfect Mantle of Siroria"] = SET_TYPE_TRIAL,
	["Perfect Vestment of Olorime"] = SET_TYPE_TRIAL,
	["Perfected Chaotic Whirlwind"] = SET_TYPE_TRIAL,
	["Perfected Claw of Yolnahkriin"] = SET_TYPE_TRIAL,
	["Perfected Concentrated Force"] = SET_TYPE_TRIAL,
	["Perfected Defensive Position"] = SET_TYPE_TRIAL,
	["Perfected Disciplined Slash"] = SET_TYPE_TRIAL,
	["Perfected Executioner's Blade"] = SET_TYPE_TRIAL,
	["Perfected Eye of Nahviintaas"] = SET_TYPE_TRIAL,
	["Perfected False God's Devotion"] = SET_TYPE_TRIAL,
	["Perfected Force Overflow"] = SET_TYPE_TRIAL,
	["Perfected Frenzied Momentum"] = SET_TYPE_TRIAL,
	["Perfected Kyne's Wind"] = SET_TYPE_TRIAL,
	["Perfected Piercing Spray"] = SET_TYPE_TRIAL,
	["Perfected Point-Blank Snipe"] = SET_TYPE_TRIAL,
	["Perfected Roaring Opportunist"] = SET_TYPE_TRIAL,
	["Perfected Timeless Blessing"] = SET_TYPE_TRIAL,
	["Perfected Tooth of Lokkestiiz"] = SET_TYPE_TRIAL,
	["Perfected Void Bash"] = SET_TYPE_TRIAL,
	["Perfected Vrol's Command"] = SET_TYPE_TRIAL,
	["Perfected Wrath of Elements"] = SET_TYPE_TRIAL,
	["Perfected Yandir's Might"] = SET_TYPE_TRIAL,
	["Pestilent Host"] = SET_TYPE_TRIAL,
	["Piercing Spray"] = SET_TYPE_TRIAL,
	["Point-Blank Snipe"] = SET_TYPE_TRIAL,
	["Poisonous Serpent"] = SET_TYPE_TRIAL,
	["Quick Serpent"] = SET_TYPE_TRIAL,
	["Roar of Alkosh"] = SET_TYPE_TRIAL,
	["Roaring Opportunist"] = SET_TYPE_TRIAL,
	["Timeless Blessing"] = SET_TYPE_TRIAL,
	["Tooth of Lokkestiiz"] = SET_TYPE_TRIAL,
	["Twice-Fanged Serpent"] = SET_TYPE_TRIAL,
	["Twilight Remedy"] = SET_TYPE_TRIAL,
	["Vestment of Olorime"] = SET_TYPE_TRIAL,
	["Vicious Serpent"] = SET_TYPE_TRIAL,
	["Void Bash"] = SET_TYPE_TRIAL,
	["Vrol's Command"] = SET_TYPE_TRIAL,
	["War Machine"] = SET_TYPE_TRIAL,
	["Wise Mage"] = SET_TYPE_TRIAL,
	["Wrath of Elements"] = SET_TYPE_TRIAL,
	["Yandir's Might"] = SET_TYPE_TRIAL,
	
	["Archer's Mind"] = SET_TYPE_ARENA,
	["Caustic Arrow"] = SET_TYPE_ARENA,
	["Cruel Flurry"] = SET_TYPE_ARENA,
	["Crushing Wall"] = SET_TYPE_ARENA,
	["Destructive Impact"] = SET_TYPE_ARENA,
	["Elemental Succession"] = SET_TYPE_ARENA,
	["Footman's Fortune"] = SET_TYPE_ARENA,
	["Gallant Charge"] = SET_TYPE_ARENA,
	["Glorious Defender"] = SET_TYPE_ARENA,
	["Grand Rejuvenation"] = SET_TYPE_ARENA,
	["Healer's Habit"] = SET_TYPE_ARENA,
	["Hunt Leader"] = SET_TYPE_ARENA,
	["Mender's Ward"] = SET_TYPE_ARENA,
	["Merciless Charge"] = SET_TYPE_ARENA,
	["Para Bellum"] = SET_TYPE_ARENA,
	["Perfected Caustic Arrow"] = SET_TYPE_ARENA,
	["Perfected Cruel Flurry"] = SET_TYPE_ARENA,
	["Perfected Crushing Wall"] = SET_TYPE_ARENA,
	["Perfected Destructive Impact"] = SET_TYPE_ARENA,
	["Perfected Gallant Charge"] = SET_TYPE_ARENA,
	["Perfected Grand Rejuvenation"] = SET_TYPE_ARENA,
	["Perfected Mender's Ward"] = SET_TYPE_ARENA,
	["Perfected Merciless Charge"] = SET_TYPE_ARENA,
	["Perfected Precise Regeneration"] = SET_TYPE_ARENA,
	["Perfected Puncturing Remedy"] = SET_TYPE_ARENA,
	["Perfected Radial Uppercut"] = SET_TYPE_ARENA,
	["Perfected Rampaging Slash"] = SET_TYPE_ARENA,
	["Perfected Spectral Cloak"] = SET_TYPE_ARENA,
	["Perfected Stinging Slashes"] = SET_TYPE_ARENA,
	["Perfected Thunderous Volley"] = SET_TYPE_ARENA,
	["Perfected Titanic Cleave"] = SET_TYPE_ARENA,
	["Perfected Virulent Shot"] = SET_TYPE_ARENA,
	["Perfected Wild Impulse"] = SET_TYPE_ARENA,
	["Permafrost"] = SET_TYPE_ARENA,
	["Precise Regeneration"] = SET_TYPE_ARENA,
	["Puncturing Remedy"] = SET_TYPE_ARENA,
	["Radial Uppercut"] = SET_TYPE_ARENA,
	["Rampaging Slash"] = SET_TYPE_ARENA,
	["Robes of Destruction Mastery"] = SET_TYPE_ARENA,
	["Spectral Cloak"] = SET_TYPE_ARENA,
	["Stinging Slashes"] = SET_TYPE_ARENA,
	["Thunderous Volley"] = SET_TYPE_ARENA,
	["Titanic Cleave"] = SET_TYPE_ARENA,
	["Virulent Shot"] = SET_TYPE_ARENA,
	["Wild Impulse"] = SET_TYPE_ARENA,
	["Winterborn"] = SET_TYPE_ARENA,

	["Black Rose"] = SET_TYPE_DROPPED,
	["Trinimac's Valor"] = SET_TYPE_DROPPED,
	["Briarheart"] = SET_TYPE_DROPPED,
	["Powerful Assault"] = SET_TYPE_DROPPED,
	["Mark of the Pariah"] = SET_TYPE_DROPPED,
	["Meritorious Service"] = SET_TYPE_DROPPED,
	["Shield Breaker"] = SET_TYPE_DROPPED,
	["Phoenix"] = SET_TYPE_DROPPED,
	["Reactive Armor"] = SET_TYPE_DROPPED,
	["Bahraha's Curse"] = SET_TYPE_DROPPED,
	["Syvarra's Scales"] = SET_TYPE_DROPPED,
	["Marksman's Crest"] = SET_TYPE_DROPPED,
	["Leki's Focus"] = SET_TYPE_DROPPED,
	["Fasalla's Guile"] = SET_TYPE_DROPPED,
	["Warrior's Fury"] = SET_TYPE_DROPPED,
	["Vicious Death"] = SET_TYPE_DROPPED,
	["Robes of Transmutation"] = SET_TYPE_DROPPED,
	["Darkstride"] = SET_TYPE_DROPPED,
	["Shadow Dancer's Raiment"] = SET_TYPE_DROPPED,
	["Hide of Morihaus"] = SET_TYPE_DROPPED,
	["Flanking Strategist"] = SET_TYPE_DROPPED,
	["Sithis' Touch"] = SET_TYPE_DROPPED,
	["Galerion's Revenge"] = SET_TYPE_DROPPED,
	["Vicecanon of Venom"] = SET_TYPE_DROPPED,
	["Thews of the Harbinger"] = SET_TYPE_DROPPED,
	["Imperial Physique"] = SET_TYPE_DROPPED,
	["Queen's Elegance"] = SET_TYPE_DROPPED,
	["Senche's Bite"] = SET_TYPE_DROPPED,
	["Aspect of Mazzatun"] = SET_TYPE_DROPPED,
	["Amber Plasm"] = SET_TYPE_DROPPED,
	["Heem-Jas' Retribution"] = SET_TYPE_DROPPED,
	["Hand of Mephala"] = SET_TYPE_DROPPED,
	["Gossamer"] = SET_TYPE_DROPPED,
	["Widowmaker"] = SET_TYPE_DROPPED,
	["Akaviri Dragonguard"] = SET_TYPE_DROPPED,
	["Silks of the Sun"] = SET_TYPE_DROPPED,
	["Shadow of the Red Mountain"] = SET_TYPE_DROPPED,
	["Syrabane's Grip"] = SET_TYPE_DROPPED,
	["Salvation"] = SET_TYPE_DROPPED,
	["Hide of the Werewolf"] = SET_TYPE_DROPPED,
	["Robes of the Withered Hand"] = SET_TYPE_DROPPED,
	["Storm Knight's Plate"] = SET_TYPE_DROPPED,
	["Necropotence"] = SET_TYPE_DROPPED,
	["Healer's Habit"] = SET_TYPE_DROPPED,
	["Alessian Order"] = SET_TYPE_DROPPED,
	["Crest of Cyrodiil"] = SET_TYPE_DROPPED,
	["Bastion of the Heartland"] = SET_TYPE_DROPPED,
	["Beckoning Steel"] = SET_TYPE_DROPPED,
	["The Juggernaut"] = SET_TYPE_DROPPED,
	["Affliction"] = SET_TYPE_DROPPED,
	["Ravager"] = SET_TYPE_DROPPED,
	["Elf Bane"] = SET_TYPE_DROPPED,
	["Desert Rose"] = SET_TYPE_DROPPED,
	["Curse Eater"] = SET_TYPE_DROPPED,
	["Almalexia's Mercy"] = SET_TYPE_DROPPED,
	["Robes of Alteration Mastery"] = SET_TYPE_DROPPED,
	["The Arch-Mage"] = SET_TYPE_DROPPED,
	["Light of Cyrodiil"] = SET_TYPE_DROPPED,
	["Buffer of the Swift"] = SET_TYPE_DROPPED,
	["Twin Sisters"] = SET_TYPE_DROPPED,
	["Shield of the Valiant"] = SET_TYPE_DROPPED,
	["Shadow Walker"] = SET_TYPE_DROPPED,
	["Hawk's Eye"] = SET_TYPE_DROPPED,
	["The Morag Tong"] = SET_TYPE_DROPPED,
	["Kyne's Kiss"] = SET_TYPE_DROPPED,
	["Ward of Cyrodiil"] = SET_TYPE_DROPPED,
	["Sentry"] = SET_TYPE_DROPPED,
	["Armor of the Veiled Heritance"] = SET_TYPE_DROPPED,
	["Way of Fire"] = SET_TYPE_DROPPED,
	["Way of Martial Knowledge"] = SET_TYPE_DROPPED,
	["Way of Air"] = SET_TYPE_DROPPED,
	["Armor of the Trainee"] = SET_TYPE_DROPPED,
	["Bloodthorn's Touch"] = SET_TYPE_DROPPED,
	["Shalk Exoskeleton"] = SET_TYPE_DROPPED,
	["Wyrd Tree's Blessing"] = SET_TYPE_DROPPED,
	["Night Mother's Embrace"] = SET_TYPE_DROPPED,
	["Plague Doctor"] = SET_TYPE_DROPPED,
	["Mother's Sorrow"] = SET_TYPE_DROPPED,
	["Wilderqueen's Arch"] = SET_TYPE_DROPPED,
	["Green Pact"] = SET_TYPE_DROPPED,
	["Night Terror"] = SET_TYPE_DROPPED,
	["Dreamer's Mantle"] = SET_TYPE_DROPPED,
	["Ranger's Gait"] = SET_TYPE_DROPPED,
	["Beekeeper's Gear"] = SET_TYPE_DROPPED,
	["Vampire Cloak"] = SET_TYPE_DROPPED,
	["Robes of the Hist"] = SET_TYPE_DROPPED,
	["Swamp Raider"] = SET_TYPE_DROPPED,
	["Hatchling's Shell"] = SET_TYPE_DROPPED,
	["Sword-Singer"] = SET_TYPE_DROPPED,
	["Order of Diagna"] = SET_TYPE_DROPPED,
	["Spinner's Garments"] = SET_TYPE_DROPPED,
	["Thunderbug's Carapace"] = SET_TYPE_DROPPED,
	["Stendarr's Embrace"] = SET_TYPE_DROPPED,
	["Fiord's Legacy"] = SET_TYPE_DROPPED,
	["Vampire Lord"] = SET_TYPE_DROPPED,
	["Spriggan's Thorns"] = SET_TYPE_DROPPED,
	["Seventh Legion Brute"] = SET_TYPE_DROPPED,
	["Skooma Smuggler"] = SET_TYPE_DROPPED,
	["Soulshine"] = SET_TYPE_DROPPED,
	["Ysgramor's Birthright"] = SET_TYPE_DROPPED,
	["Witchman Armor"] = SET_TYPE_DROPPED,
	["Draugr's Heritage"] = SET_TYPE_DROPPED,
	["Prisoner's Rags"] = SET_TYPE_DROPPED,
	["Stygian"] = SET_TYPE_DROPPED,
	["Meridia's Blessed Armor"] = SET_TYPE_DROPPED,
	["Sanctuary"] = SET_TYPE_DROPPED,
	["Jailbreaker"] = SET_TYPE_DROPPED,
	["Tormentor"] = SET_TYPE_DROPPED,
	["Spelunker"] = SET_TYPE_DROPPED,
	["Spider Cultist Cowl"] = SET_TYPE_DROPPED,
	["Light Speaker"] = SET_TYPE_DROPPED,
	["Undaunted Bastion"] = SET_TYPE_DROPPED,
	["Combat Physician"] = SET_TYPE_DROPPED,
	["Toothrow"] = SET_TYPE_DROPPED,
	["Netch's Touch"] = SET_TYPE_DROPPED,
	["Strength of the Automaton"] = SET_TYPE_DROPPED,
	["Burning Spellweave"] = SET_TYPE_DROPPED,
	["Sunderflame"] = SET_TYPE_DROPPED,
	["Embershield"] = SET_TYPE_DROPPED,
	["Hircine's Veneer"] = SET_TYPE_DROPPED,
	["Sword Dancer"] = SET_TYPE_DROPPED,
	["Treasure Hunter"] = SET_TYPE_DROPPED,
	["Duneripper's Scales"] = SET_TYPE_DROPPED,
	["Shroud of the Lich"] = SET_TYPE_DROPPED,
	["Leviathan"] = SET_TYPE_DROPPED,
	["Ebon Armory"] = SET_TYPE_DROPPED,
	["Lamia's Song"] = SET_TYPE_DROPPED,
	["Undaunted Infiltrator"] = SET_TYPE_DROPPED,
	["Medusa"] = SET_TYPE_DROPPED,
	["Magicka Furnace"] = SET_TYPE_DROPPED,
	["Draugr Hulk"] = SET_TYPE_DROPPED,
	["Undaunted Unweaver"] = SET_TYPE_DROPPED,
	["Bone Pirate's Tatters"] = SET_TYPE_DROPPED,
	["Knight-errant's Mail"] = SET_TYPE_DROPPED,
	["Prayer Shawl"] = SET_TYPE_DROPPED,
	["Knightmare"] = SET_TYPE_DROPPED,
	["Viper's Sting"] = SET_TYPE_DROPPED,
	["Dreugh King Slayer"] = SET_TYPE_DROPPED,
	["Barkskin"] = SET_TYPE_DROPPED,
	["Sergeant's Mail"] = SET_TYPE_DROPPED,
	["Armor of Truth"] = SET_TYPE_DROPPED,
	["Crusader"] = SET_TYPE_DROPPED,
	["The Ice Furnace"] = SET_TYPE_DROPPED,
	["Vestments of the Warlock"] = SET_TYPE_DROPPED,
	["Durok's Bane"] = SET_TYPE_DROPPED,
	["Noble Duelist's Silks"] = SET_TYPE_DROPPED,
	["Nikulas' Heavy Armor"] = SET_TYPE_DROPPED,
	["Overwhelming Surge"] = SET_TYPE_DROPPED,
	["Storm Master"] = SET_TYPE_DROPPED,
	["Jolting Arms"] = SET_TYPE_DROPPED,
	["The Worm's Raiment"] = SET_TYPE_DROPPED,
	["Oblivion's Edge"] = SET_TYPE_DROPPED,
	["Rattlecage"] = SET_TYPE_DROPPED,
	["Scathing Mage"] = SET_TYPE_DROPPED,
	["Sheer Venom"] = SET_TYPE_DROPPED,
	["Leeching Plate"] = SET_TYPE_DROPPED,
	["Spell Power Cure"] = SET_TYPE_DROPPED,
	["Essence Thief"] = SET_TYPE_DROPPED,
	["Brands of Imperium"] = SET_TYPE_DROPPED,
	["Poisonous Serpent"] = SET_TYPE_DROPPED,
	["Warrior-Poet"] = SET_TYPE_DROPPED,
	["War Maiden"] = SET_TYPE_DROPPED,
	["Infector"] = SET_TYPE_DROPPED,
	["Vanguard's Challenge"] = SET_TYPE_DROPPED,
	["Coward's Gear"] = SET_TYPE_DROPPED,
	["Knight Slayer"] = SET_TYPE_DROPPED,
	["Wizard's Riposte"] = SET_TYPE_DROPPED,
	["Impregnable Armor"] = SET_TYPE_DROPPED,
	["Ironblood"] = SET_TYPE_DROPPED,
	["Draugr's Rest"] = SET_TYPE_DROPPED,
	["Pillar of Nirn"] = SET_TYPE_DROPPED,
	["Hagraven's Garden"] = SET_TYPE_DROPPED,
	["Flame Blossom"] = SET_TYPE_DROPPED,
	["Blooddrinker"] = SET_TYPE_DROPPED,
	["Ulfnor's Favor"] = SET_TYPE_DROPPED,
	["Caluurion's Legacy"] = SET_TYPE_DROPPED,
	["Trappings of Invigoration"] = SET_TYPE_DROPPED,
	["Curse of Doylemish"] = SET_TYPE_DROPPED,
	["Jorvuld's Guidance"] = SET_TYPE_DROPPED,
	["Plague Slinger"] = SET_TYPE_DROPPED,
	["Mad Tinkerer"] = SET_TYPE_DROPPED,
	["Unfathomable Darkness"] = SET_TYPE_DROPPED,
	["Livewire"] = SET_TYPE_DROPPED,
	["Grace of Gloom"] = SET_TYPE_DROPPED,
	["Gryphon's Ferocity"] = SET_TYPE_DROPPED,
	["Wisdom of Vanus"] = SET_TYPE_DROPPED,
	["Haven of Ursus"] = SET_TYPE_DROPPED,
	["Hanu's Compassion"] = SET_TYPE_DROPPED,
	["Blood Moon"] = SET_TYPE_DROPPED,
	["Jailer's Tenacity"] = SET_TYPE_DROPPED,
	["Moon Hunter"] = SET_TYPE_DROPPED,
	["Savage Werewolf"] = SET_TYPE_DROPPED,
	["Champion of the Hist"] = SET_TYPE_DROPPED,
	["Dead-Water's Guile"] = SET_TYPE_DROPPED,
	["Bright-Throat's Boast"] = SET_TYPE_DROPPED,
	["Indomitable Fury"] = SET_TYPE_DROPPED,
	["Spell Strategist"] = SET_TYPE_DROPPED,
	["Battlefield Acrobat"] = SET_TYPE_DROPPED,
	["Soldier of Anguish"] = SET_TYPE_DROPPED,
	["Steadfast Hero"] = SET_TYPE_DROPPED,
	["Battalion Defender"] = SET_TYPE_DROPPED,
	["Mighty Glacier"] = SET_TYPE_DROPPED,
	["Tzogvin's Warband"] = SET_TYPE_DROPPED,
	["Icy Conjuror"] = SET_TYPE_DROPPED,
	["Frozen Watcher"] = SET_TYPE_DROPPED,
	["Scavenging Demise"] = SET_TYPE_DROPPED,
	["Auroran's Thunder"] = SET_TYPE_DROPPED,
	["Deadly Strike"] = SET_TYPE_DROPPED,
	["Call of the Undertaker"] = SET_TYPE_DROPPED,
	["Crafty Alfiq"] = SET_TYPE_DROPPED,
	["Vesture of Darloc Brae"] = SET_TYPE_DROPPED,
	["Renald's Resolve"] = SET_TYPE_DROPPED,
	["Hollowfang Thirst"] = SET_TYPE_DROPPED,
	["Dro'Zakar's Claws"] = SET_TYPE_DROPPED,
	["Dragon's Defilement"] = SET_TYPE_DROPPED,
	["Z'en's Redress"] = SET_TYPE_DROPPED,
	["Azureblight Reaper"] = SET_TYPE_DROPPED,
	["Senchal Defender"] = SET_TYPE_DROPPED,
	["Marauder's Haste"] = SET_TYPE_DROPPED,
	["Dragonguard Elite"] = SET_TYPE_DROPPED,
	["Hiti's Hearth"] = SET_TYPE_DROPPED,
	["Titanborn Strength"] = SET_TYPE_DROPPED,
	["Bani's Torment"] = SET_TYPE_DROPPED,
	["Draugrkin's Grip"] = SET_TYPE_DROPPED,
	["Aegis Caller"] = SET_TYPE_DROPPED,
	["Grave Guardian"] = SET_TYPE_DROPPED,
	["Winter's Respite"] = SET_TYPE_DROPPED,
	["Venomous Smite"] = SET_TYPE_DROPPED,
	["Eternal Vigor"] = SET_TYPE_DROPPED,
	["Talfyg's Treachery"] = SET_TYPE_DROPPED,
	["Unleashed Terror"] = SET_TYPE_DROPPED,
	["Crimson Twilight"] = SET_TYPE_DROPPED,
	["Elemental Catalyst"] = SET_TYPE_DROPPED,
	["Kraglen's Howl"] = SET_TYPE_DROPPED,
	["Arkasis's Genius"] = SET_TYPE_DROPPED,
	
	["Defiler"] = SET_TYPE_DROPPED
}

local categoryNameBySetType = {
	[1] = "Monster Sets",
	[2] = "Mythic Sets",
	[3] = "Jewelry Sets",
	[4] = "Crafted Sets",
	[5] = "Dropped Sets",
	[6] = "Trial Sets",
	[7] = "Arena Sets"
}

local mainCategoryIcons = {
	["Monster Sets"] = "/esoui/art/icons/gear_undauntedcrocodile_head_a.dds",
	["Jewelry Sets"] = "/esoui/art/crafting/smithing_multiple_jewelryslot.dds",
	["Mythic Sets"] = "EsoUI/Art/Journal/Gamepad/GP_journal_tabIcon_antiquities.dds",
	
	["Dropped Sets"] = "/esoui/art/crafting/smithing_multiple_armorslot.dds",
	["Trail Sets"] = "/esoui/art/crafting/smithing_multiple_armorslot.dds",
	["Arena Sets"] = "/esoui/art/crafting/smithing_multiple_armorslot.dds",
	["Crafted Sets"] = "/esoui/art/crafting/smithing_multiple_armorslot.dds",
}
local subCategoryIcons = {
	["All"] = "/esoui/art/inventory/inventory_tabicon_all_up.dds",
	["Armor"] = "/esoui/art/crafting/gamepad/gp_smithing_multiple_armorslot.dds",
	["Weapons"] = "/esoui/art/crafting/gamepad/gp_smithing_multiple_weaponslot.dds",
	["Jewelry"] = "/esoui/art/crafting/gamepad/gp_smithing_multiple_jewelryslot.dds",
}

function IJAGI_InitiateDestroyItem(inventorySlot)
    if IsSlotLocked(inventorySlot) then
        ZO_Alert(UI_ALERT_CATEGORY_ERROR, SOUNDS.NEGATIVE_CLICK, GetString(SI_ERROR_ITEM_LOCKED))
        return false
    end
    SetCursorItemSoundsEnabled(false)
	
	local bag, index = ZO_Inventory_GetBagAndIndex(inventorySlot)
	CallSecureProtected("PickupInventoryItem", bagId, slotIndex)
    SetCursorItemSoundsEnabled(true)
    -- Initiates the destruction request...(could either abandon quest or destroy the item)
    PlaceInWorldLeftClick()
    return true
end
-------------------
-- Helper functions
-------------------
local EQUIP_SLOT

local function cancelTooltipLoop()
	isTooltipLoop = false
	EVENT_MANAGER:UnregisterForUpdate("IJAGI_TooltipLoop")
	EQUIP_SLOT = 0
end

local function GetCategoryTypeFromWeaponType(weaponType)
	if weaponType == WEAPONTYPE_AXE or weaponType == WEAPONTYPE_HAMMER or weaponType == WEAPONTYPE_SWORD or weaponType == WEAPONTYPE_DAGGER then
		return GAMEPAD_WEAPON_CATEGORY_ONE_HANDED_MELEE
	elseif weaponType == WEAPONTYPE_TWO_HANDED_SWORD or weaponType == WEAPONTYPE_TWO_HANDED_AXE or weaponType == WEAPONTYPE_TWO_HANDED_HAMMER then
		return GAMEPAD_WEAPON_CATEGORY_TWO_HANDED_MELEE
	elseif weaponType == WEAPONTYPE_FIRE_STAFF or weaponType == WEAPONTYPE_FROST_STAFF or weaponType == WEAPONTYPE_LIGHTNING_STAFF then
		return GAMEPAD_WEAPON_CATEGORY_DESTRUCTION_STAFF
	elseif weaponType == WEAPONTYPE_HEALING_STAFF then
		return GAMEPAD_WEAPON_CATEGORY_RESTORATION_STAFF
	elseif weaponType == WEAPONTYPE_BOW then
		return GAMEPAD_WEAPON_CATEGORY_TWO_HANDED_BOW
	elseif weaponType ~= WEAPONTYPE_NONE then
		return GAMEPAD_WEAPON_CATEGORY_UNCATEGORIZED
	end
end
local function IsTwoHandedWeaponCategory(categoryType)
	return categoryType == GAMEPAD_WEAPON_CATEGORY_TWO_HANDED_MELEE or
		categoryType == GAMEPAD_WEAPON_CATEGORY_DESTRUCTION_STAFF or
		categoryType == GAMEPAD_WEAPON_CATEGORY_RESTORATION_STAFF or
		categoryType == GAMEPAD_WEAPON_CATEGORY_TWO_HANDED_BOW
end
local function isItemMap(itemData)
	if itemData.specializedItemType == 100 then
		return true
	elseif itemData.specializedItemType == 101 then
		return true
	end
end
local function filterDisabled(itemData)
	if itemData.isJunk then
		if IJAGI.savedVariables.filterJunk then
			return false
		else
			return true
		end
	end
	if itemData.stolen then
		if IJAGI.savedVariables.filterStolen then
			return false
		else
			return true
		end
	end
	if isItemMap(itemData) then
		if IJAGI.savedVariables.filterMaps then
			return false
		else
			return true
		end
	end
end

local function IsStolenItem(itemData)
	local isStolen = itemData.stolen
	if optFilterFunction then
		return isStolen and optFilterFunction(itemData)
	else
		return isStolen
	end
end
local function IsJunkItem(itemData)
	local isJunk = itemData.isJunk
	if optFilterFunction then
		return isJunk and optFilterFunction(itemData)
	else
		return isJunk
	end
--[[	
	if not itemData.stolen then
		return IsItemJunk(itemData.bagId, itemData.slotIndex)
	end
--]]
end
local function IsMap(itemData)
	local isMap = isItemMap(itemData)
	if optFilterFunction then
		return isMap and optFilterFunction(itemData)
	else
		return isMap
	end
end
local function Contains(text, ...)
    if text == nil or text == "" then
        return nil
    end
    if type(text) == "table" then
        local msg = "text is table! @Equal()"
        d("|c88aaff" .. self.name .. ":|r |cFF0000" .. msg .. "|r")
        return false
    end

    local keyList = {...}
    if type(keyList[1]) == "table" then
        keyList = keyList[1]
    end


    local lowerText = string.lower(text)
    local result
    for _, key in ipairs(keyList) do
        if key and key ~= "" then
		key = "^" .. key .. "$"
            result, result2 = string.match(text, key)
            if result then
                return result, result2
            end
            local lowerKey = string.lower(key)
            if lowerText and lowerKey then
                result, result2 = string.match(lowerText, lowerKey)
                if result then
                    return result, result2
                end
            end
        end
    end
    return nil
end
local function categoryNotEmpty(filterType)
	local bagCache = SHARED_INVENTORY:GenerateFullSlotData(nil, BAG_BACKPACK)
	for slotId, itemData in pairs(bagCache) do
		if filterType == ITEMFILTERTYPE_JUNK then
			if (itemData.isJunk and not itemData.stolen) then return true end
		elseif filterType == "map" then
			if itemData.specializedItemType == 100 then
				return true
			elseif itemData.specializedItemType == 101 then
				return true
			end
		else
			if not itemData.isJunk or not itemData.stolen then
				if Contains(filterType, itemData.filterData) then return true end
			end
		end
	end
end
local function shouldShowNewSupplies()
	local bagCache = SHARED_INVENTORY:GenerateFullSlotData(nil, BAG_BACKPACK)
	for slotId, itemData in pairs(bagCache) do
		if itemData.brandNew and ZO_InventoryUtils_DoesNewItemMatchSupplies(itemData) then
			if not (itemData.isJunk or itemData.stolen) then
				return true	
			end
		end
	end
end

local function areAnyItemsNew(filterType)
	local bagCache = SHARED_INVENTORY:GenerateFullSlotData(filterType, BAG_BACKPACK)
	for slotId, slotData in pairs(bagCache) do
		if slotData.brandNew then -- slotData.stolen and
			return true
		end
	end
end

local DEFAULT_SORT_KEYS ={
	bestGamepadItemCategoryName = { tiebreaker = "name" },
	name = { tiebreaker = "requiredLevel" },
	requiredLevel = { tiebreaker = "requiredChampionPoints", isNumeric = true },
	requiredChampionPoints = { tiebreaker = "iconFile", isNumeric = true },
	iconFile = { tiebreaker = "uniqueId" },
	uniqueId = { isId64 = true },
	customSortOrder = { tiebreaker = "bestGamepadItemCategoryName", isNumeric = true },
	isJunk = { tiebreaker = "bestGamepadItemCategoryName" },
	
	equipType = { tiebreaker = "bestGamepadItemCategoryName", isNumeric = true },
	itemType = { tiebreaker = "bestGamepadItemCategoryName", isNumeric = true },
	specializedItemType = { tiebreaker = "itemType", isNumeric = true },
	
	setName = { tiebreaker = "specializedItemType", tieBreakerSortOrder = ZO_SORT_ORDER_DOWN },
--	setCategoryName = { tiebreaker = "setName", tieBreakerSortOrder = ZO_SORT_ORDER_UP },
	categoryMode = { tiebreaker = "setName", tieBreakerSortOrder = ZO_SORT_ORDER_UP, isNumeric = true },
	
	setType = { tiebreaker = "categoryMode", tieBreakerSortOrder = ZO_SORT_ORDER_UP, isNumeric = true },
}
	
local function sortJunkToTOP(data1, data2)
	if data1.isJunk or data2.isJunk then
		return ZO_TableOrderingFunction(data1, data2, "isJunk", DEFAULT_SORT_KEYS, ZO_SORT_ORDER_DOWN)
	end
	return ZO_TableOrderingFunction(data1, data2, "bestGamepadItemCategoryName", DEFAULT_SORT_KEYS, ZO_SORT_ORDER_UP)
end
local function sortJunkToBottom(data1, data2)
	if data1.isJunk or data2.isJunk then
		return ZO_TableOrderingFunction(data1, data2, "isJunk", DEFAULT_SORT_KEYS, ZO_SORT_ORDER_UP)
	end
	return ZO_TableOrderingFunction(data1, data2, "bestGamepadItemCategoryName", DEFAULT_SORT_KEYS, ZO_SORT_ORDER_UP)
end
local function sortSetItems(data1, data2)
	if data1.setType or data2.setType then
		return ZO_TableOrderingFunction(data1, data2, "setType", DEFAULT_SORT_KEYS, ZO_SORT_ORDER_UP)
	end
	return ZO_TableOrderingFunction(data1, data2, "bestGamepadItemCategoryName", DEFAULT_SORT_KEYS, ZO_SORT_ORDER_UP)
end

local SELL_SORT_KEYS ={
	bestGamepadItemCategoryName = { tiebreaker = "name" },
	name = { tiebreaker = "requiredLevel" },
	requiredLevel = { tiebreaker = "requiredChampionPoints", isNumeric = true },
	requiredChampionPoints = { tiebreaker = "iconFile", isNumeric = true },
	iconFile = { tiebreaker = "uniqueId" },
	uniqueId = { isId64 = true },
	customSortOrder = { tiebreaker = "bestGamepadItemCategoryName", isNumeric = true },
	isJunk = { tiebreaker = "customSortOrder", tieBreakerSortOrder = ZO_SORT_ORDER_UP }
}
local function SellSortFunc(data1, data2)
	if data1.isJunk or data2.isJunk then
		return ZO_TableOrderingFunction(data1, data2, "isJunk", SELL_SORT_KEYS, ZO_SORT_ORDER_DOWN)
	end
	return ZO_TableOrderingFunction(data1, data2, "customSortOrder", SELL_SORT_KEYS, ZO_SORT_ORDER_UP)
end

-------------------------------------
local equipmentSlot = {
	[EQUIP_TYPE_NECK] = EQUIP_SLOT_NECK,
	[EQUIP_TYPE_RING] = EQUIP_SLOT_RING1,
	
	[EQUIP_TYPE_MAIN_HAND] = EQUIP_SLOT_MAIN_HAND,
	[EQUIP_TYPE_OFF_HAND] = EQUIP_SLOT_OFF_HAND,
	
	[EQUIP_TYPE_HEAD] = EQUIP_SLOT_HEAD,
	[EQUIP_TYPE_SHOULDERS] = EQUIP_SLOT_SHOULDERS,
	[EQUIP_TYPE_CHEST] = EQUIP_SLOT_CHEST,
	[EQUIP_TYPE_HAND] = EQUIP_SLOT_HAND,
	[EQUIP_TYPE_WAIST] = EQUIP_SLOT_WAIST,
	[EQUIP_TYPE_LEGS] = EQUIP_SLOT_LEGS,
	[EQUIP_TYPE_FEET] = EQUIP_SLOT_FEET
}
local slotName = {
	[EQUIP_SLOT_RING1] = "Ring 1",
	[EQUIP_SLOT_RING2] = "Ring 2",
	
	[EQUIP_SLOT_MAIN_HAND] = "Main hand",
	[EQUIP_SLOT_OFF_HAND] = "Off hand",
	[EQUIP_SLOT_BACKUP_MAIN] = "Backup Main hand",
	[EQUIP_SLOT_BACKUP_OFF] = "Backup Off hand",
}
local function GetEquippedItemType(slotId)
	local weaponType = GetItemWeaponType(BAG_WORN, slotId)
    local _, _, _, _, _, equipType = GetItemInfo(BAG_WORN, slotId)
    return equipType, weaponType
end
local function areShields(equipWeaponType, weaponType)
	if equipWeaponType == WEAPONTYPE_SHIELD then
		return weaponType == WEAPONTYPE_SHIELD
	else
		return true
	end
end
local function shouldLoopTooltip(EQUIP_SLOT, weaponType)
	if not isTooltipLoop then
		local categoryType = GetCategoryTypeFromWeaponType(weaponType)
		local equipType, equipWeaponType = GetEquippedItemType(EQUIP_SLOT)
		--	or EQUIP_SLOT == EQUIP_SLOT_RING2
		return EQUIP_SLOT == EQUIP_SLOT_RING1
			or (EQUIP_SLOT == EQUIP_SLOT_MAIN_HAND and not IsTwoHandedWeaponCategory(categoryType) and equipType ~= EQUIP_TYPE_TWO_HAND)
	end
end

-------------------------------------
-- Gamepad Player Inventory List
-------------------------------------
function IJAGI_UpdateTooltipEquippedIndicatorText(tooltipType, equipSlot)
     local isHidden, highestPriorityVisualLayerThatIsShowing = WouldEquipmentBeHidden(equipSlot or EQUIP_SLOT_NONE)
     local equipSlotText = ""
    if equipSlot == EQUIP_SLOT_MAIN_HAND then
        equipSlotText = GetString(SI_GAMEPAD_EQUIPPED_MAIN_HAND_ITEM_HEADER)
    elseif equipSlot == EQUIP_SLOT_BACKUP_MAIN then
        equipSlotText = GetString(SI_GAMEPAD_EQUIPPED_BACKUP_MAIN_ITEM_HEADER)
    elseif equipSlot == EQUIP_SLOT_OFF_HAND then
        equipSlotText = GetString(SI_GAMEPAD_EQUIPPED_OFF_HAND_ITEM_HEADER)
    elseif equipSlot == EQUIP_SLOT_BACKUP_OFF then
        equipSlotText = GetString(SI_GAMEPAD_EQUIPPED_BACKUP_OFF_ITEM_HEADER)
    elseif equipSlot == EQUIP_SLOT_RING1 then
        equipSlotText = GetString(SI_EQUIPSLOT11)
    elseif equipSlot == EQUIP_SLOT_RING2 then
        equipSlotText = GetString(SI_EQUIPSLOT12)
     end
     if isHidden then
          GAMEPAD_TOOLTIPS:SetStatusLabelText(tooltipType, GetString(SI_GAMEPAD_EQUIPPED_ITEM_HEADER), equipSlotText, ZO_SELECTED_TEXT:Colorize(GetHiddenByStringForVisualLayer(highestPriorityVisualLayerThatIsShowing)))
     else
          GAMEPAD_TOOLTIPS:SetStatusLabelText(tooltipType, GetString(SI_GAMEPAD_EQUIPPED_ITEM_HEADER), equipSlotText)
     end
end
function IJAGI:UpdateRightTooltip()
	local selectedItemData = GAMEPAD_INVENTORY.currentlySelectedData
	local weaponType = GetItemWeaponType(selectedItemData.bagId, selectedItemData.slotIndex)
	
	if weaponType > 0 then
		if weaponType == WEAPONTYPE_SHIELD then
			EQUIP_SLOT = equipmentSlot[EQUIP_TYPE_OFF_HAND]
		else
			if EQUIP_SLOT == EQUIP_SLOT_MAIN_HAND or EQUIP_SLOT == EQUIP_SLOT_BACKUP_MAIN then
				EQUIP_SLOT = EQUIP_SLOT_OFF_HAND
			else
				EQUIP_SLOT = equipmentSlot[EQUIP_TYPE_MAIN_HAND]
			end
			
			if GetActiveHotbarCategory() == HOTBAR_CATEGORY_BACKUP then
				-- add 16 for backup bar slot ids
				-- EQUIP_SLOT_MAIN_HAND + 16 = EQUIP_SLOT_BACKUP_MAIN
				-- EQUIP_SLOT_OFF_HAND + 16 = EQUIP_SLOT_BACKUP_OFF
				EQUIP_SLOT = EQUIP_SLOT + 16
			end
		end
	else
		--	armor or rings
		local  _, _, _, _, _, equipType, _, _ = GetItemInfo(selectedItemData.bagId, selectedItemData.slotIndex)
		if EQUIP_SLOT == EQUIP_SLOT_RING1 then
			EQUIP_SLOT = EQUIP_SLOT_RING2
		else
			EQUIP_SLOT = equipmentSlot[equipType]
		end
	end

	local equipType, equipWeaponType = GetEquippedItemType(EQUIP_SLOT)
	
--	if equipType ~= EQUIP_TYPE_INVALID and areShields(equipWeaponType, weaponType) then
	if equipType ~= EQUIP_TYPE_INVALID then
		local equipSlotHasItem = select(2, GetEquippedItemInfo(EQUIP_SLOT))
		if selectedItemData and (not equipSlotHasItem or GAMEPAD_INVENTORY.savedVars.useStatComparisonTooltip) then
			GAMEPAD_TOOLTIPS:LayoutItemStatComparison(GAMEPAD_RIGHT_TOOLTIP, selectedItemData.bagId, selectedItemData.slotIndex, EQUIP_SLOT)
			GAMEPAD_TOOLTIPS:SetStatusLabelText(GAMEPAD_RIGHT_TOOLTIP, GetString(SI_GAMEPAD_INVENTORY_ITEM_COMPARE_TOOLTIP_TITLE))
			--	update header text to show what hand/ring is being compared
			IJAGI_UpdateTooltipEquippedIndicatorText(GAMEPAD_RIGHT_TOOLTIP, EQUIP_SLOT)
		elseif GAMEPAD_TOOLTIPS:LayoutBagItem(GAMEPAD_RIGHT_TOOLTIP, BAG_WORN, EQUIP_SLOT) then
			IJAGI_UpdateTooltipEquippedIndicatorText(GAMEPAD_RIGHT_TOOLTIP, EQUIP_SLOT)
		end
	end
	
	-- do update for rings and one hand weapons if not a 2 hand or shield equipped
	if EQUIP_SLOT > 0 then
		if shouldLoopTooltip(EQUIP_SLOT, weaponType) then
			EVENT_MANAGER:RegisterForUpdate("IJAGI_TooltipLoop", 1500, function() IJAGI:UpdateRightTooltip() end)
			isTooltipLoop = true
		end
	end
end

------------------------------------- Item filters
local function GetBestQuestItemCategoryDescription(questItemData)
	if questItemData.isJunk then
		return zo_strformat(SI_INVENTORY_HEADER, GetString(SI_ITEMFILTERTYPE9))
	end
	local questItemCategory = GAMEPAD_QUEST_ITEM_CATEGORY_NOT_SLOTTABLE
	if CanQuickslotQuestItemById(questItemData.questItemId) then
		questItemCategory = GAMEPAD_QUEST_ITEM_CATEGORY_SLOTTABLE
	end

	return GetString("SI_GAMEPADQUESTITEMCATEGORY", questItemCategory)
	
end
local function GetItemDataFilterComparator(filteredEquipSlot, nonEquipableFilterType)
	return function(itemData)
		if filteredEquipSlot then
			return ZO_Character_DoesEquipSlotUseEquipType(filteredEquipSlot, itemData.equipType)
		end

		if nonEquipableFilterType then
			return ZO_InventoryUtils_DoesNewItemMatchFilterType(itemData, nonEquipableFilterType)
		end
		
		return ZO_InventoryUtils_DoesNewItemMatchSupplies(itemData)
	end
end

local function GetBestStoreItemCategoryDescription(itemData)
	if itemData.storeGroup == STORE_COLLECTIBLE_GROUP then
		local collectibleCategory = GetCollectibleCategoryTypeFromLink(itemData.itemLink)
		return GetString("SI_COLLECTIBLECATEGORYTYPE", collectibleCategory)
	elseif itemData.storeGroup == STORE_QUEST_ITEMS_GROUP then
		return GetString(SI_ITEM_FORMAT_STR_QUEST_ITEM)
	elseif itemData.storeGroup == STORE_ANTIQUITY_LEADS_GROUP then
		return GetString(SI_GAMEPAD_VENDOR_ANTIQUITY_LEAD_GROUP_HEADER)
	else
		return ZO_InventoryUtils_Gamepad_GetBestItemCategoryDescription(itemData)
	end
end
local function GetBestSellItemCategoryDescription(itemData)
	local traitType = GetItemTrait(itemData.bagId, itemData.slotIndex)
	if itemData.isJunk then
		return GetString(SI_ITEMFILTERTYPE9)
	elseif traitType == ITEM_TRAIT_TYPE_WEAPON_ORNATE or traitType == ITEM_TRAIT_TYPE_ARMOR_ORNATE or traitType == ITEM_TRAIT_TYPE_JEWELRY_ORNATE then
		return GetString("SI_ITEMTRAITTYPE", traitType)
	else
		return GetBestStoreItemCategoryDescription(itemData)
	end
end

------------------------------------- Update Player inventory category headers
------------------------------------- adds total in gold for junk and stolen items
local ITEM_TYPE_TO_CATEGORY_MAP = {
	[ITEMTYPE_REAGENT] = GAMEPAD_ITEM_CATEGORY_ALCHEMY,
	[ITEMTYPE_POTION_BASE] = GAMEPAD_ITEM_CATEGORY_ALCHEMY,
	[ITEMTYPE_POISON_BASE] = GAMEPAD_ITEM_CATEGORY_ALCHEMY,
	[ITEMTYPE_LURE] = GAMEPAD_ITEM_CATEGORY_BAIT,
	[ITEMTYPE_BLACKSMITHING_RAW_MATERIAL] = GAMEPAD_ITEM_CATEGORY_BLACKSMITH,
	[ITEMTYPE_BLACKSMITHING_MATERIAL] = GAMEPAD_ITEM_CATEGORY_BLACKSMITH,
	[ITEMTYPE_BLACKSMITHING_BOOSTER] = GAMEPAD_ITEM_CATEGORY_BLACKSMITH,
	[ITEMTYPE_CLOTHIER_RAW_MATERIAL] = GAMEPAD_ITEM_CATEGORY_CLOTHIER,
	[ITEMTYPE_CLOTHIER_MATERIAL] = GAMEPAD_ITEM_CATEGORY_CLOTHIER,
	[ITEMTYPE_CLOTHIER_BOOSTER] = GAMEPAD_ITEM_CATEGORY_CLOTHIER,
	[ITEMTYPE_FOOD] = GAMEPAD_ITEM_CATEGORY_CONSUMABLE,
	[ITEMTYPE_DRINK] = GAMEPAD_ITEM_CATEGORY_CONSUMABLE,
	[ITEMTYPE_RECIPE] = GAMEPAD_ITEM_CATEGORY_CONSUMABLE,
	[ITEMTYPE_COSTUME] = GAMEPAD_ITEM_CATEGORY_COSTUME,
	[ITEMTYPE_ENCHANTING_RUNE_POTENCY] = GAMEPAD_ITEM_CATEGORY_ENCHANTING,
	[ITEMTYPE_ENCHANTING_RUNE_ASPECT] = GAMEPAD_ITEM_CATEGORY_ENCHANTING,
	[ITEMTYPE_ENCHANTING_RUNE_ESSENCE] = GAMEPAD_ITEM_CATEGORY_ENCHANTING,
	[ITEMTYPE_GLYPH_WEAPON] = GAMEPAD_ITEM_CATEGORY_GLYPHS,
	[ITEMTYPE_GLYPH_ARMOR] = GAMEPAD_ITEM_CATEGORY_GLYPHS,
	[ITEMTYPE_GLYPH_JEWELRY] = GAMEPAD_ITEM_CATEGORY_GLYPHS,
	[ITEMTYPE_JEWELRYCRAFTING_RAW_MATERIAL] = GAMEPAD_ITEM_CATEGORY_JEWELRYCRAFTING,
	[ITEMTYPE_JEWELRYCRAFTING_MATERIAL] = GAMEPAD_ITEM_CATEGORY_JEWELRYCRAFTING,
	[ITEMTYPE_JEWELRYCRAFTING_RAW_BOOSTER] = GAMEPAD_ITEM_CATEGORY_JEWELRYCRAFTING,
	[ITEMTYPE_JEWELRYCRAFTING_BOOSTER] = GAMEPAD_ITEM_CATEGORY_JEWELRYCRAFTING,
	[ITEMTYPE_POTION] = GAMEPAD_ITEM_CATEGORY_POTION,
	[ITEMTYPE_INGREDIENT] = GAMEPAD_ITEM_CATEGORY_PROVISIONING,
	[ITEMTYPE_ADDITIVE] = GAMEPAD_ITEM_CATEGORY_PROVISIONING,
	[ITEMTYPE_SPICE] = GAMEPAD_ITEM_CATEGORY_PROVISIONING,
	[ITEMTYPE_FLAVORING] = GAMEPAD_ITEM_CATEGORY_PROVISIONING,
	[ITEMTYPE_SIEGE] = GAMEPAD_ITEM_CATEGORY_SIEGE,
	[ITEMTYPE_AVA_REPAIR] = GAMEPAD_ITEM_CATEGORY_SIEGE,
	[ITEMTYPE_SPELLCRAFTING_TABLET] = GAMEPAD_ITEM_CATEGORY_SPELLCRAFTING,
	[ITEMTYPE_RACIAL_STYLE_MOTIF] = GAMEPAD_ITEM_CATEGORY_STYLE_MATERIAL,
	[ITEMTYPE_STYLE_MATERIAL] = GAMEPAD_ITEM_CATEGORY_STYLE_MATERIAL,
	[ITEMTYPE_SOUL_GEM] = GAMEPAD_ITEM_CATEGORY_SOUL_GEM,
	[ITEMTYPE_LOCKPICK] = GAMEPAD_ITEM_CATEGORY_TOOL,
	[ITEMTYPE_TOOL] = GAMEPAD_ITEM_CATEGORY_TOOL,
	[ITEMTYPE_ARMOR_TRAIT] = GAMEPAD_ITEM_CATEGORY_TRAIT_ITEM,
	[ITEMTYPE_WEAPON_TRAIT] = GAMEPAD_ITEM_CATEGORY_TRAIT_ITEM,
	[ITEMTYPE_JEWELRY_RAW_TRAIT] = GAMEPAD_ITEM_CATEGORY_TRAIT_ITEM,
	[ITEMTYPE_JEWELRY_TRAIT] = GAMEPAD_ITEM_CATEGORY_TRAIT_ITEM,
	[ITEMTYPE_TROPHY] = GAMEPAD_ITEM_CATEGORY_TROPHY,
	[ITEMTYPE_WOODWORKING_RAW_MATERIAL] = GAMEPAD_ITEM_CATEGORY_WOODWORKING,
	[ITEMTYPE_WOODWORKING_MATERIAL] = GAMEPAD_ITEM_CATEGORY_WOODWORKING,
	[ITEMTYPE_WOODWORKING_BOOSTER] = GAMEPAD_ITEM_CATEGORY_WOODWORKING,
}
local function GetCategoryFromItemType(itemType)
	-- This is not an exhaustive map: when we don't have a category we'll just use the raw itemtype instead.
	return ITEM_TYPE_TO_CATEGORY_MAP[itemType]
end
local WEAPON_TYPE_TO_CATEGORY_MAP = {
	[WEAPONTYPE_AXE] = GAMEPAD_ITEM_CATEGORY_AXE,
	[WEAPONTYPE_TWO_HANDED_AXE] = GAMEPAD_ITEM_CATEGORY_AXE,
	[WEAPONTYPE_BOW] = GAMEPAD_ITEM_CATEGORY_BOW,
	[WEAPONTYPE_DAGGER] = GAMEPAD_ITEM_CATEGORY_DAGGER,
	[WEAPONTYPE_HAMMER] = GAMEPAD_ITEM_CATEGORY_HAMMER,
	[WEAPONTYPE_TWO_HANDED_HAMMER] = GAMEPAD_ITEM_CATEGORY_HAMMER,
	[WEAPONTYPE_SHIELD] = GAMEPAD_ITEM_CATEGORY_SHIELD,
	[WEAPONTYPE_HEALING_STAFF] = GAMEPAD_ITEM_CATEGORY_STAFF,
	[WEAPONTYPE_FIRE_STAFF] = GAMEPAD_ITEM_CATEGORY_STAFF,
	[WEAPONTYPE_FROST_STAFF] = GAMEPAD_ITEM_CATEGORY_STAFF,
	[WEAPONTYPE_LIGHTNING_STAFF] = GAMEPAD_ITEM_CATEGORY_STAFF,
	[WEAPONTYPE_SWORD] = GAMEPAD_ITEM_CATEGORY_SWORD,
	[WEAPONTYPE_TWO_HANDED_SWORD] = GAMEPAD_ITEM_CATEGORY_SWORD,
}
local function GetCategoryFromWeapon(itemData)
	local weaponType
	if itemData.isJunk then
		return zo_strformat(SI_INVENTORY_HEADER, GetString(SI_ITEMFILTERTYPE9))
	end
	if itemData.bagId and itemData.slotIndex then
		weaponType = GetItemWeaponType(itemData.bagId, itemData.slotIndex)
	else
		weaponType = GetItemLinkWeaponType(itemData.itemLink)
	end
	local category = WEAPON_TYPE_TO_CATEGORY_MAP[weaponType]
	internalassert(category)
	return category
end
local ARMOR_EQUIP_TYPE_TO_CATEGORY_MAP = {
	[EQUIP_TYPE_CHEST] = GAMEPAD_ITEM_CATEGORY_CHEST,
	[EQUIP_TYPE_FEET] = GAMEPAD_ITEM_CATEGORY_FEET,
	[EQUIP_TYPE_HAND] = GAMEPAD_ITEM_CATEGORY_HANDS,
	[EQUIP_TYPE_HEAD] = GAMEPAD_ITEM_CATEGORY_HEAD,
	[EQUIP_TYPE_LEGS] = GAMEPAD_ITEM_CATEGORY_LEGS,
	[EQUIP_TYPE_NECK] = GAMEPAD_ITEM_CATEGORY_AMULET,
	[EQUIP_TYPE_RING] = GAMEPAD_ITEM_CATEGORY_RING,
	[EQUIP_TYPE_SHOULDERS] = GAMEPAD_ITEM_CATEGORY_SHOULDERS,
	[EQUIP_TYPE_WAIST] = GAMEPAD_ITEM_CATEGORY_WAIST,
}
local function GetCategoryFromArmor(itemData)
	if itemData.isJunk then
		return zo_strformat(SI_INVENTORY_HEADER, GetString(SI_ITEMFILTERTYPE9))
	end
	local category = ARMOR_EQUIP_TYPE_TO_CATEGORY_MAP[itemData.equipType]
	internalassert(category)
	return category
end
local function UpdateGold(control)
	ZO_CurrencyControl_SetSimpleCurrency(control, CURT_MONEY, GetCurrencyAmount(CURT_MONEY, CURRENCY_LOCATION_CHARACTER), ZO_GAMEPAD_CURRENCY_OPTIONS_LONG_FORMAT)
	return true
end
local function UpdateCapacityString()
	return zo_strformat(SI_GAMEPAD_INVENTORY_CAPACITY_FORMAT, GetNumBagUsedSlots(BAG_BACKPACK), GetBagSize(BAG_BACKPACK))
end
local function UpdateSellValueString(control)
	local bagCache = SHARED_INVENTORY:GenerateFullSlotData(nil, BAG_BACKPACK)
	local total = 0
	
	for slotId, itemData in pairs(bagCache) do
		if (itemData.isJunk and IJAGI.showJunk) or (itemData.stolen and IJAGI.showStolen) then
			local sellPrice = (itemData.sellPrice * itemData.stackCount)
			total = total + sellPrice
		end
	end
	return zo_strformat(SI_TOOLTIP_ITEM_VALUE_FORMAT, total, GetString(SI_GAMEPAD_INVENTORY_AVAILABLE_FUNDS))
end
--[[
ZO_PreHook(GAMEPAD_INVENTORY, "InitializeHeader", function(self)
	self.customHeaderData = {
		data1HeaderText = GetString(SI_GAMEPAD_INVENTORY_AVAILABLE_FUNDS),
		data1Text = UpdateGold,

		data2HeaderText = GetString(SI_GAMEPAD_INVENTORY_CAPACITY),
		data2Text = UpdateCapacityString,
			
		data3HeaderText = GetString(SI_INVENTORY_SORT_TYPE_PRICE),
		data3Text = UpdateSellValueString,
	}
	return false
end)
ZO_PreHook(GAMEPAD_INVENTORY, "RefreshHeader", function(self, blockCallback)
	if addOnName ~= IJAGI.name then
		return false
	end
--	if not self.categoryList:GetTargetData() then return false end
	local currentList = self:GetCurrentList()
	local headerData
	
	local isLocal = false
	
	IJAGI.showJunk = false
	IJAGI.showStolen = false
	
	if self.categoryList:GetTargetData().showJunk ~= nil then
		IJAGI.showJunk = true
		self.customHeaderData.titleText = GetString(SI_ITEMFILTERTYPE9)
		headerData = self.customHeaderData
		isLocal = true
	elseif self.categoryList:GetTargetData().showStolen ~= nil then
		IJAGI.showStolen = true
		self.customHeaderData.titleText = GetString(SI_GAMEPAD_ITEM_STOLEN_LABEL)
		headerData = self.customHeaderData
		isLocal = true
	else
		return false
	end
	if isLocal then
		ZO_GamepadGenericHeader_Refresh(self.header, headerData, blockCallback)
		return true
	else
		return false
	end
end)
--]]

local TOTAL_SETS = 0
local function UpdateSetItemCount()
	return TOTAL_SETS
end

ZO_PreHook(GAMEPAD_INVENTORY, "RefreshHeader", function(self, blockCallback)
	local currentList = self:GetCurrentList()
	local headerData
	
	IJAGI.showJunk = false
	IJAGI.showStolen = false
	
	if currentList == self.craftBagList then
		headerData = self.craftBagHeaderData
	elseif currentList == self.categoryList then
		headerData = self.categoryHeaderData
		
	elseif currentList == IJAGI.categorySetList then
		headerData = self.setCategoryHeaderData
	elseif currentList == IJAGI.itemSetList then
		headerData = self.setListHeaderData
		
	elseif self.categoryList:GetTargetData().showJunk ~= nil then
		IJAGI.showJunk = true
		self.customHeaderData.titleText = GetString(SI_ITEMFILTERTYPE9)
		headerData = self.customHeaderData
	elseif self.categoryList:GetTargetData().showStolen ~= nil then
		IJAGI.showStolen = true
		self.customHeaderData.titleText = GetString(SI_GAMEPAD_ITEM_STOLEN_LABEL)
		headerData = self.customHeaderData
	else
		return false
	end

	ZO_GamepadGenericHeader_Refresh(self.header, headerData, blockCallback)
	return true
end)

ZO_PreHook(GAMEPAD_INVENTORY, "InitializeHeader", function(self)
    local function UpdateTitleText()
        return self.categoryList:GetTargetData().text
    end
    local tabBarEntries =
        {
            {
                text = GetString(SI_GAMEPAD_INVENTORY_CATEGORY_HEADER),
                callback = function()
                    self:SwitchActiveList(INVENTORY_CATEGORY_LIST)
                end,
            },
            {
                text = GetString(SI_GAMEPAD_INVENTORY_CRAFT_BAG_HEADER),
                callback = function()
                    self:SwitchActiveList(INVENTORY_CRAFT_BAG_LIST)
                end,
            },
            {
                text = "Item Sets",
                callback = function()
                    self:SwitchActiveList(SET_CATEGORY_LIST)
                end,
            }
        }

    self.categoryHeaderData = {
        tabBarEntries = tabBarEntries,
        data1HeaderText = GetString(SI_GAMEPAD_INVENTORY_AVAILABLE_FUNDS),
        data1Text = UpdateGold,
        data2HeaderText = GetString(SI_GAMEPAD_INVENTORY_CAPACITY),
        data2Text = UpdateCapacityString,
    }
    self.craftBagHeaderData = {
        tabBarEntries = tabBarEntries,
        data1HeaderText = GetString(SI_GAMEPAD_INVENTORY_AVAILABLE_FUNDS),
        data1Text = UpdateGold,
    }
    self.itemListHeaderData = {
        titleText = UpdateTitleText,
        data1HeaderText = GetString(SI_GAMEPAD_INVENTORY_AVAILABLE_FUNDS),
        data1Text = UpdateGold,
        data2HeaderText = GetString(SI_GAMEPAD_INVENTORY_CAPACITY),
        data2Text = UpdateCapacityString,
    }
	
	self.customHeaderData = {
		data1HeaderText = GetString(SI_GAMEPAD_INVENTORY_AVAILABLE_FUNDS),
		data1Text = UpdateGold,

		data2HeaderText = GetString(SI_GAMEPAD_INVENTORY_CAPACITY),
		data2Text = UpdateCapacityString,
			
		data3HeaderText = GetString(SI_INVENTORY_SORT_TYPE_PRICE),
		data3Text = UpdateSellValueString,
	}
    self.setCategoryHeaderData = {
        tabBarEntries = tabBarEntries,
        data1HeaderText = GetString(SI_GAMEPAD_INVENTORY_AVAILABLE_FUNDS),
        data1Text = UpdateGold,
		
        data2HeaderText = GetString(SI_GAMEPAD_INVENTORY_CAPACITY),
        data2Text = UpdateCapacityString,
		
		data3HeaderText = "Total Sets",
		data3Text = UpdateSetItemCount,
    }
	
    self.setListHeaderData = {
        data1HeaderText = GetString(SI_GAMEPAD_INVENTORY_AVAILABLE_FUNDS),
        data1Text = UpdateGold,
		
        data2HeaderText = GetString(SI_GAMEPAD_INVENTORY_CAPACITY),
        data2Text = UpdateCapacityString,

		data3HeaderText = "Total Sets",
		data3Text = UpdateSetItemCount,
    }
	
    ZO_GamepadGenericHeader_Initialize(self.header, ZO_GAMEPAD_HEADER_TABBAR_CREATE)
	return true
end)

-------------------------------------
local function GetBestItemCategoryDescriptionForOther(itemData)
	local category = nil
	if itemData.itemType == ITEMTYPE_WEAPON then
		category = GetCategoryFromWeapon(itemData)
	elseif itemData.itemType == ITEMTYPE_ARMOR then
		category = GetCategoryFromArmor(itemData)
	else
		category = GetCategoryFromItemType(itemData.itemType)
	end
	if category then
		return GetString("SI_GAMEPADITEMCATEGORY", category)
	end
	return zo_strformat(SI_INVENTORY_HEADER, GetString("SI_ITEMTYPE", itemData.itemType))
end
local function GetBestItemCategoryDescription(itemData)
	if itemData.isJunk then
		itemData.sellInformationSortOrder = 1
		return zo_strformat(SI_INVENTORY_HEADER, GetString(SI_ITEMFILTERTYPE9))
	end
	
	if itemData.specializedItemType == 100 then
		return zo_strformat(SI_INVENTORY_HEADER, GetString(SI_SPECIALIZEDITEMTYPE100))
	end
	if itemData.specializedItemType == 101 then
		return zo_strformat(SI_INVENTORY_HEADER, GetString(SI_SPECIALIZEDITEMTYPE101))
	end
	
	if itemData.itemType == ITEMTYPE_FURNISHING then
		local furnitureDataId = GetItemFurnitureDataId(itemData.bagId, itemData.slotIndex)
		if furnitureDataId ~= 0 then
			local categoryId, subcategoryId = GetFurnitureDataCategoryInfo(furnitureDataId)
			if categoryId then
				local categoryName = GetFurnitureCategoryInfo(categoryId)
				if categoryName ~= "" then
					return categoryName
				end
			end
		end
	end

	local categoryType = GetCategoryTypeFromWeaponType(GetItemWeaponType(itemData.bagId, itemData.slotIndex))
	if categoryType ==GAMEPAD_WEAPON_CATEGORY_UNCATEGORIZED then
		local weaponType = GetItemWeaponType(itemData.bagId, itemData.slotIndex)
		return GetString("SI_WEAPONTYPE", weaponType)
	elseif categoryType then
		return GetString("SI_GAMEPADWEAPONCATEGORY", categoryType)
	end

	local armorType = GetItemArmorType(itemData.bagId, itemData.slotIndex)
	if armorType ~= ARMORTYPE_NONE then
		return GetString("SI_ARMORTYPE", armorType)
	end

	return GetBestItemCategoryDescriptionForOther(itemData)

end
function ZO_InventoryUtils_Gamepad_GetBestItemCategoryDescription(itemData)
	local category = nil
	if itemData.isJunk then
		return GetString(SI_ITEMFILTERTYPE9)
	end
	if itemData.itemType == ITEMTYPE_WEAPON then
		category = GetCategoryFromWeapon(itemData)
	elseif itemData.itemType == ITEMTYPE_ARMOR then
		category = GetCategoryFromArmor(itemData)
	else
		category = GetCategoryFromItemType(itemData.itemType)
	end
	if category then
		return GetString("SI_GAMEPADITEMCATEGORY", category)
	end
	return zo_strformat(SI_INVENTORY_HEADER, GetString("SI_ITEMTYPE", itemData.itemType))
end

-------------------------------------

-------------------------------------
ZO_PreHook(GAMEPAD_INVENTORY, "RefreshCategoryList", function(self)
	self.categoryList:Clear()
	
	do -- Currencies
		local name = GetString(SI_INVENTORY_CURRENCIES)
		local iconFile = "EsoUI/Art/Inventory/Gamepad/gp_inventory_icon_currencies.dds"
		local data = ZO_GamepadEntryData:New(name, iconFile, nil, nil, false)
		data.isCurrencyEntry = true
		data:SetIconTintOnSelection(true)
		self.categoryList:AddEntry("ZO_GamepadItemEntryTemplate", data)
	end

	do -- Supplies
		local isListEmpty = self:IsItemListEmpty()
		if not isListEmpty then
			local name = GetString(SI_INVENTORY_SUPPLIES)
			local iconFile = "EsoUI/Art/Inventory/Gamepad/gp_inventory_icon_all.dds"
	--		local hasAnyNewItems = SHARED_INVENTORY:AreAnyItemsNew(ZO_InventoryUtils_DoesNewItemMatchSupplies, nil, BAG_BACKPACK)
			local data = ZO_GamepadEntryData:New(name, iconFile, nil, nil, shouldShowNewSupplies())
			data:SetIconTintOnSelection(true)
			self.categoryList:AddEntry("ZO_GamepadItemEntryTemplate", data)
		end
	end

	-- Materials
	if categoryNotEmpty(ITEMFILTERTYPE_CRAFTING)then
		self:AddFilteredBackpackCategoryIfPopulated(ITEMFILTERTYPE_CRAFTING, "EsoUI/Art/Inventory/Gamepad/gp_inventory_icon_materials.dds")
	end
	-- Consumables
	if categoryNotEmpty(ITEMFILTERTYPE_QUICKSLOT)then
		self:AddFilteredBackpackCategoryIfPopulated(ITEMFILTERTYPE_QUICKSLOT, "EsoUI/Art/Inventory/Gamepad/gp_inventory_icon_quickslot.dds")
	end
	-- Furnishing
	if categoryNotEmpty(ITEMFILTERTYPE_FURNISHING)then
		self:AddFilteredBackpackCategoryIfPopulated(ITEMFILTERTYPE_FURNISHING, "EsoUI/Art/Crafting/Gamepad/gp_crafting_menuIcon_furnishings.dds")
	end
	
	do -- Quest Items
		local questCache = SHARED_INVENTORY:GenerateFullQuestCache()
		if next(questCache) then
			local name = GetString(SI_GAMEPAD_INVENTORY_QUEST_ITEMS)
			local iconFile = "EsoUI/Art/Inventory/Gamepad/gp_inventory_icon_quest.dds"
			local data = ZO_GamepadEntryData:New(name, iconFile)
			data.filterType = ITEMFILTERTYPE_QUEST
			data:SetIconTintOnSelection(true)
			self.categoryList:AddEntry("ZO_GamepadItemEntryTemplate", data)
		end
	end
		
	local function areAnyItemsNew(filterType)
		local bagCache = SHARED_INVENTORY:GenerateFullSlotData(filterType, BAG_BACKPACK)
		for slotId, slotData in pairs(bagCache) do
			if slotData.brandNew then -- slotData.stolen and
				return true
			end
		end
	end

	do -- Treasure Maps and Survey Reports
		if categoryNotEmpty("map") and IJAGI.savedVariables.mapsCategory then
			local name = "Maps"
			local iconFile = "/esoui/art/crafting/gamepad/gp_crafting_menuicon_designs.dds"
			local data = ZO_GamepadEntryData:New(name, iconFile, nil, nil, areAnyItemsNew(IsMap))
			data.showMaps = true
			data:SetIconTintOnSelection(true)
			self.categoryList:AddEntry("ZO_GamepadItemEntryTemplate", data)
		end
	end

	do -- Junked Items
		if categoryNotEmpty(ITEMFILTERTYPE_JUNK) and IJAGI.savedVariables.junkCategory then
			local name = GetString(SI_ITEMFILTERTYPE9)
			local iconFile = "esoui/art/inventory/inventory_tabicon_junk_up.dds"
			local data = ZO_GamepadEntryData:New(name, iconFile, nil, nil, areAnyItemsNew(IsJunkItem))
			data.showJunk = true
			data:SetIconTintOnSelection(true)
			self.categoryList:AddEntry("ZO_GamepadItemEntryTemplate", data)
		end
	end

	do -- Stolen Items
		if(AreAnyItemsStolen(BAG_BACKPACK)) and IJAGI.savedVariables.stolenCategory then
			local name = GetString(SI_GAMEPAD_ITEM_STOLEN_LABEL)
			local iconFile = "esoui/art/inventory/gamepad/gp_inventory_icon_stolenitem.dds"
			local data = ZO_GamepadEntryData:New(name, iconFile, nil, nil, areAnyItemsNew(IsStolenItem))
			data.showStolen = true
			data:SetIconTintOnSelection(true)
			self.categoryList:AddEntry("ZO_GamepadItemEntryTemplate", data)
		end
	end
		
	local twoHandIconFile
	local headersUsed = {}
	for i, equipSlot in ZO_Character_EnumerateOrderedEquipSlots() do -- equipable items
		local locked = IsLockedWeaponSlot(equipSlot)
		local isListEmpty = self:IsItemListEmpty(equipSlot, nil)
		if not locked and not isListEmpty then
			local name = zo_strformat(SI_CHARACTER_EQUIP_SLOT_FORMAT, GetString("SI_EQUIPSLOT", equipSlot))
			local iconFile, slotHasItem = GetEquippedItemInfo(equipSlot)
			if not slotHasItem then
				iconFile = nil
			end

			--special case where a two handed weapon icon shows up in offhand slot at lower opacity
			local weaponCategoryType = GetCategoryTypeFromWeaponType(GetItemWeaponType(BAG_WORN, equipSlot))
			if iconFile
				and (equipSlot == EQUIP_SLOT_MAIN_HAND or equipSlot == EQUIP_SLOT_BACKUP_MAIN)
				and IsTwoHandedWeaponCategory(weaponCategoryType) then
				twoHandIconFile = iconFile
			end

			local offhandTransparency
			if twoHandIconFile and (equipSlot == EQUIP_SLOT_OFF_HAND or equipSlot == EQUIP_SLOT_BACKUP_OFF) then
				iconFile = twoHandIconFile
				twoHandIconFile = nil
				offhandTransparency = 0.5
			end

			local function DoesNewItemMatchEquipSlot(itemData)
				return ZO_Character_DoesEquipSlotUseEquipType(equipSlot, itemData.equipType)
			end

			local hasAnyNewItems = SHARED_INVENTORY:AreAnyItemsNew(DoesNewItemMatchEquipSlot, nil, BAG_BACKPACK)
			
			local data = ZO_GamepadEntryData:New(name, iconFile, nil, nil, hasAnyNewItems)
			data:SetMaxIconAlpha(offhandTransparency)
			data.equipSlot = equipSlot
			data.filterType = (GetItemFilterTypeInfo(BAG_WORN, equipSlot)) -- first filter only

			if (equipSlot == EQUIP_SLOT_POISON or equipSlot == EQUIP_SLOT_BACKUP_POISON) then
				data.stackCount = select(2, GetItemInfo(BAG_WORN, equipSlot))
			end

			--Headers for Equipment Visual Categories (Weapons, Apparel, Accessories): display header for the first equip slot of a category to be visible
			local visualCategory = ZO_Character_GetEquipSlotVisualCategory(equipSlot)
			if headersUsed[visualCategory] == nil then
				self.categoryList:AddEntry("ZO_GamepadItemEntryTemplateWithHeader", data)
				data:SetHeader(GetString("SI_EQUIPSLOTVISUALCATEGORY", visualCategory))

				headersUsed[visualCategory] = true
			--No Header Needed
			else
				self.categoryList:AddEntry("ZO_GamepadItemEntryTemplate", data)
			end
		end
	end

	self.categoryList:Commit()
	return true
end)
-------------------------------------

ZO_PreHook(GAMEPAD_INVENTORY, "RefreshItemList", function(self)
	if addOnName ~= IJAGI.name then
		return false
	end
	self.itemList:Clear()
	if self.categoryList:IsEmpty() then return end
	
	local targetCategoryData 		= self.categoryList:GetTargetData()
	local filteredEquipSlot 		= targetCategoryData.equipSlot
	local nonEquipableFilterType 	= targetCategoryData.filterType
	local showMapCategory 			= targetCategoryData.showMaps
	local showJunkCategory 			= targetCategoryData.showJunk
	local showStolenCategory 		= targetCategoryData.showStolen

	local filteredDataTable
		
		local isQuestItemFilter = nonEquipableFilterType == ITEMFILTERTYPE_QUEST
	--special case for quest items
	if isQuestItemFilter then
		filteredDataTable = {}
		local questCache = SHARED_INVENTORY:GenerateFullQuestCache()
		for _, questItems in pairs(questCache) do
			for _, questItem in pairs(questItems) do
				table.insert(filteredDataTable, questItem)
				questItem.bestItemCategoryName = zo_strformat(SI_INVENTORY_HEADER, GetBestQuestItemCategoryDescription(questItem))
			end
		end
		table.sort(filteredDataTable, ZO_GamepadInventory_QuestItemSortComparator)
	else
		local comparator = GetItemDataFilterComparator(filteredEquipSlot, nonEquipableFilterType)
		if showJunkCategory then
			filteredDataTable = SHARED_INVENTORY:GenerateFullSlotData(IsJunkItem, BAG_BACKPACK, BAG_WORN)
		elseif showStolenCategory then
			filteredDataTable = SHARED_INVENTORY:GenerateFullSlotData(IsStolenItem, BAG_BACKPACK, BAG_WORN)
		elseif showMapCategory then
			filteredDataTable = SHARED_INVENTORY:GenerateFullSlotData(IsMap, BAG_BACKPACK, BAG_WORN)
--				table.sort(filteredDataTable, function(data1, data2) return ZO_TableOrderingFunction(data1, data2, "specializedItemType", DEFAULT_SORT_KEYS, ZO_SORT_ORDER_UP)  end)
		else
			filteredDataTable = SHARED_INVENTORY:GenerateFullSlotData(comparator, BAG_BACKPACK, BAG_WORN)
		end	
		for _, itemData in pairs(filteredDataTable) do
			itemData.bestItemCategoryName = zo_strformat(SI_INVENTORY_HEADER, GetBestItemCategoryDescription(itemData))
		end
		table.sort(filteredDataTable, ZO_GamepadInventory_DefaultItemSortComparator)
	end
	
	local lastBestItemCategoryName
	
	local function addToList(itemData, entryData)
		if itemData.bestItemCategoryName ~= lastBestItemCategoryName then
			lastBestItemCategoryName = itemData.bestItemCategoryName

			entryData:SetHeader(lastBestItemCategoryName)
			self.itemList:AddEntry("ZO_GamepadItemSubEntryTemplateWithHeader", entryData)
		else
			self.itemList:AddEntry("ZO_GamepadItemSubEntryTemplate", entryData)
		end
	end

	for i, itemData in ipairs(filteredDataTable) do
		local entryData = ZO_GamepadEntryData:New(itemData.name, itemData.iconFile)
		entryData:InitializeInventoryVisualData(itemData)

		if itemData.bagId == BAG_WORN then
			entryData.isEquippedInCurrentCategory = itemData.slotIndex == filteredEquipSlot
			entryData.isHiddenByWardrobe = WouldEquipmentBeHidden(itemData.slotIndex or EQUIP_SLOT_NONE)
			
		elseif isQuestItemFilter then
			local slotIndex = FindActionSlotMatchingSimpleAction(ACTION_TYPE_QUEST_ITEM, itemData.questItemId)
			entryData.isEquippedInCurrentCategory = slotIndex ~= nil
		else
			local slotIndex = FindActionSlotMatchingItem(itemData.bagId, itemData.slotIndex)
			entryData.isEquippedInCurrentCategory = slotIndex ~= nil
		end

		local remaining, duration
		if isQuestItemFilter then
			if itemData.toolIndex then
				remaining, duration = GetQuestToolCooldownInfo(itemData.questIndex, itemData.toolIndex)
			elseif itemData.stepIndex and itemData.conditionIndex then
				remaining, duration = GetQuestItemCooldownInfo(itemData.questIndex, itemData.stepIndex, itemData.conditionIndex)
			end

			ZO_InventorySlot_SetType(entryData, SLOT_TYPE_QUEST_ITEM)
		else
			remaining, duration = GetItemCooldownInfo(itemData.bagId, itemData.slotIndex)

			ZO_InventorySlot_SetType(entryData, SLOT_TYPE_GAMEPAD_INVENTORY_ITEM)
		end
		if remaining > 0 and duration > 0 then
			entryData:SetCooldown(remaining, duration)
		end

		entryData:SetIgnoreTraitInformation(true)

		entryData.isMap = isItemMap(itemData)

		if showStolenCategory and itemData.stolen then
			addToList(itemData, entryData)
		elseif showJunkCategory and itemData.isJunk then
			if itemData.stolen then
				if filterDisabled(itemData) then addToList(itemData, entryData) end
			else
				addToList(itemData, entryData)
			end
		elseif showMapCategory and entryData.isMap then
			if itemData.isJunk then
				if filterDisabled(itemData) then addToList(itemData, entryData) end
			else
				addToList(itemData, entryData)
			end
		else
			if itemData.isJunk or itemData.stolen or entryData.isMap then
				if filterDisabled(itemData) then addToList(itemData, entryData) end
			else
				addToList(itemData, entryData)
			end
		end
	end
	self.itemList:Commit()
	self:RefreshActiveKeybinds()
	self:RefreshItemActions()
	return true
end)
-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

ZO_PreHook(GAMEPAD_INVENTORY, "OnDeferredInitialize", function(self)
	IJAGI:InitializeKeybindStrip()
	IJAGI:InitializeCategorySetList()
	IJAGI:InitializeSetItemList()
	
	local function OnInventoryUpdated(bagId)
		self:MarkDirty()
		local currentList = self:GetCurrentList()
		if self.scene:IsShowing() then
			-- we only want to update immediately if we are in the gamepad inventory scene
			if currentList == IJAGI.categorySetList then
				IJAGI:RefreshCategorySetList()
			elseif currentList == IJAGI.itemSetList then
				KEYBIND_STRIP:UpdateKeybindButton(IJAGI.toggleCompareModeKeybindStripDescriptor)
			end
        end
    end
    SHARED_INVENTORY:RegisterCallback("FullInventoryUpdate", OnInventoryUpdated)
    SHARED_INVENTORY:RegisterCallback("SingleSlotInventoryUpdate", OnInventoryUpdated)
	return false
end)

ZO_PreHook(GAMEPAD_INVENTORY, "OnUpdate", function(self, currentFrameTimeSeconds)
	if self.actionMode == SET_ITEM_LIST_ACTION_MODE then
		if not currentFrameTimeSeconds or (self.nextUpdateTimeSeconds and (currentFrameTimeSeconds >= self.nextUpdateTimeSeconds)) then
			self.nextUpdateTimeSeconds = nil
			IJAGI:RefreshSetItemList()
			if IJAGI.itemSetList:IsEmpty() then
				self:SwitchActiveList(SET_CATEGORY_LIST)
			else
				cancelTooltipLoop()
				IJAGI:UpdateRightTooltip()
				self:RefreshItemActions()
			end
			return true
		end
	elseif self.actionMode == SET_CATEGORY_ACTION_MODE then
		if not currentFrameTimeSeconds or (self.nextUpdateTimeSeconds and (currentFrameTimeSeconds >= self.nextUpdateTimeSeconds)) then
			self.nextUpdateTimeSeconds = nil
			IJAGI:RefreshCategorySetList()
			self:UpdateCategoryLeftTooltip(IJAGI.categorySetList:GetTargetData())
			return true
		end
	else
		return false
	end
end)

ZO_PreHook(GAMEPAD_INVENTORY, "SwitchActiveList", function(self, listDescriptor)
    if listDescriptor == self.currentListType then return false end
	cancelTooltipLoop()
    if self.scene:IsShowing() then
		if listDescriptor == SET_CATEGORY_LIST or listDescriptor == SET_ITEM_LIST then
			self.previousListType = self.currentListType
			self.currentListType = listDescriptor
			
			-- TODO: Better way to handle this?
		
			if self.previousListType == SET_ITEM_LIST then
				KEYBIND_STRIP:RemoveKeybindButton(IJAGI.toggleCompareModeKeybindStripDescriptor)
				self.listWaitingOnDestroyRequest = nil
				self:TryClearNewStatusOnHidden()
				ZO_SavePlayerConsoleProfile()
			end
			
			GAMEPAD_TOOLTIPS:Reset(GAMEPAD_LEFT_TOOLTIP)
			GAMEPAD_TOOLTIPS:Reset(GAMEPAD_RIGHT_TOOLTIP)
			
			if listDescriptor == SET_CATEGORY_LIST then
	            IJAGI:RefreshCategorySetList()
				self:SetCurrentList(IJAGI.categorySetList)

				self:SetActiveKeybinds(IJAGI.categorySetListKeybindStripDescriptor)

				self:SetSelectedItemUniqueId(self:GenerateItemSlotData(IJAGI.categorySetList:GetTargetData()))
				self.actionMode = SET_CATEGORY_ACTION_MODE
				self:RefreshHeader()
				self:ActivateHeader()
			elseif listDescriptor == SET_ITEM_LIST then
--				self:SetActiveKeybinds(IJAGI.setItemFilterKeybindStripDescriptor)
				self:SetActiveKeybinds(self.setItemFilterKeybindStripDescriptor)

	            IJAGI:RefreshSetItemList()
				self:SetCurrentList(IJAGI.itemSetList)
				
				if not KEYBIND_STRIP:HasKeybindButton(IJAGI.toggleCompareModeKeybindStripDescriptor) then
					KEYBIND_STRIP:AddKeybindButton(IJAGI.toggleCompareModeKeybindStripDescriptor)
				end
				
				self:SetSelectedItemUniqueId(IJAGI.itemSetList:GetTargetData())
				self.actionMode = SET_ITEM_LIST_ACTION_MODE
				self:RefreshItemActions()
				IJAGI:UpdateRightTooltip()
				self:RefreshHeader(BLOCK_TABBAR_CALLBACK)
				self:DeactivateHeader()
			end
			self:RefreshActiveKeybinds()
			return true
		else
			return false
		end
    end
end)

ZO_PreHook(GAMEPAD_INVENTORY, "RefreshItemActions", function(self)
    if self.actionMode == SET_ITEM_LIST_ACTION_MODE then
        targetData = IJAGI.itemSetList:GetTargetData()
		targetData.slotType = SLOT_TYPE_CRAFTING_COMPONENT
		GAMEPAD_INVENTORY:SetSelectedInventoryData(targetData)
		return true
    elseif self.actionMode == SET_CATEGORY_ACTION_MODE then
        targetData = self:GenerateItemSlotData(IJAGI.categorySetList:GetTargetData())
		return true
	else
		return false
    end
end)

local bankIcon = "/esoui/art/tooltips/icon_bank.dds"
-------------------
-- Category List --
-------------------
--[[
function IJAGI:RefreshItemActions()
    local targetData
    local actionMode = self.actionMode
    if actionMode == SET_ITEM_LIST_ACTION_MODE then
        targetData = self.itemSetList:GetTargetData()
    end
    GAMEPAD_INVENTORY:SetSelectedInventoryData(targetData)
end
--]]
local function SetupCategoryList(list)
    list:AddDataTemplate("ZO_GamepadItemEntryTemplate", ZO_SharedGamepadEntry_OnSetup, ZO_GamepadMenuEntryTemplateParametricListFunction)
    list:AddDataTemplateWithHeader("ZO_GamepadItemEntryTemplate", ZO_SharedGamepadEntry_OnSetup, ZO_GamepadMenuEntryTemplateParametricListFunction, nil, "ZO_GamepadMenuEntryHeaderTemplate")
end

function IJAGI:InitializeCategorySetList()
    self.categorySetList = GAMEPAD_INVENTORY:AddList("Sets", SetupCategoryList)
    self.categorySetList:SetNoItemText(GetString(SI_GAMEPAD_INVENTORY_EMPTY))

    --Match the tooltip to the selected data because it looks nicer
    local function OnSelectedCategoryChanged(list, selectedData)
        GAMEPAD_INVENTORY:UpdateCategoryLeftTooltip(selectedData)
    end

    self.categorySetList:SetOnSelectedDataChangedCallback(OnSelectedCategoryChanged)

    --Match the functionality to the target data
    local function OnTargetCategoryChanged(list, targetData)
        if targetData then
            GAMEPAD_INVENTORY:SetSelectedItemUniqueId(GAMEPAD_INVENTORY:GenerateItemSlotData(targetData))
            GAMEPAD_INVENTORY.selectedItemFilterType = targetData.filterType
        else
            GAMEPAD_INVENTORY:SetSelectedItemUniqueId(nil)
        end

        GAMEPAD_INVENTORY.currentlySelectedData = targetData
        KEYBIND_STRIP:UpdateKeybindButtonGroup(self.categorySetListKeybindStripDescriptor)
    end

    self.categorySetList:SetOnTargetDataChangedCallback(OnTargetCategoryChanged)
end

local equipmentSortOrder = {
	[EQUIP_TYPE_HEAD] = 1,
	[EQUIP_TYPE_SHOULDERS] = 2,
	[EQUIP_TYPE_CHEST] = 3,
	[EQUIP_TYPE_HAND] = 4,
	[EQUIP_TYPE_WAIST] = 5,
	[EQUIP_TYPE_LEGS] = 6,
	[EQUIP_TYPE_FEET] = 7,
	
	[EQUIP_TYPE_NECK] = 21,
	[EQUIP_TYPE_RING] = 22
}

local weaponSortOrder = {
	[WEAPONTYPE_SHIELD] = 8,
	[WEAPONTYPE_AXE] = 9,
	[WEAPONTYPE_HAMMER] = 10,
	[WEAPONTYPE_SWORD] = 11,

	[WEAPONTYPE_TWO_HANDED_SWORD] = 12,
	[WEAPONTYPE_TWO_HANDED_AXE] = 13,
	[WEAPONTYPE_TWO_HANDED_HAMMER] = 14,

	[WEAPONTYPE_DAGGER] = 15,
	[WEAPONTYPE_FIRE_STAFF] = 16,
	[WEAPONTYPE_LIGHTNING_STAFF] = 17,
	[WEAPONTYPE_FROST_STAFF] = 18,
	[WEAPONTYPE_HEALING_STAFF] = 19,
	[WEAPONTYPE_BOW] = 20
}

local function getSubCategoryData(itemData)
	local subCategoryName
	if itemData.setType > 3 then
		local weaponType = GetItemWeaponType(itemData.bagId, itemData.slotIndex)
		if weaponType > 0 then
			subCategoryName = "Weapons"
		else
			if itemData.equipSort < 12 then
				subCategoryName = "Armor"
			else
				subCategoryName = "Jewelry"
			end
		end
	else
		subCategoryName = "All"
	end
	local iconFile = subCategoryIcons[subCategoryName]
	return subCategoryName, iconFile
end

local function getSetData(itemData)
	local itemLink = GetItemLink(itemData.bagId, itemData.slotIndex)
	local isSet, setName = GetItemLinkSetInfo(itemLink)
	if isSet then
		itemData.setType = setTypeByName[setName]
		itemData.setName = setName
		itemData.bestItemCategoryName = setName
		return setName, setTypeByName[setName], isSet, setName
	end
end

local function setEquipSort(itemData)
	local weaponType = GetItemWeaponType(itemData.bagId, itemData.slotIndex)
	if weaponType > 0 then
		itemData.equipSort = weaponSortOrder[weaponType]
	else
		local  _, _, _, _, _, equipType, _, _ = GetItemInfo(itemData.bagId, itemData.slotIndex)
		itemData.equipSort = equipmentSortOrder[equipType]
	end
end

local function GetSetItemDataFilterComparator(categoryMode, categoryType)
	return function(itemData)
		if itemData.equipType > 0 then
			local setName, setType, isSet, bestItemCategoryName = getSetData(itemData)
		
			if isSet and categoryType == setType then
				setEquipSort(itemData)
				getSetData(itemData)
				local subCategoryName = getSubCategoryData(itemData)
				if categoryMode > 0 then
					local compareMode = subCategoryModes[subCategoryName] or 0
					return categoryMode == compareMode
				else
					return true
				end
			end
		end
	end
end

local function GetSetCategoryDataFilterComparator()
	return function(itemData)
		if itemData.equipType > 0 then
			local setName, setType, isSet, bestItemCategoryName = getSetData(itemData)
			
			if setType == nil and setName then d( "Set missing from the list " .. setName) end
			if isSet and setType ~= nil then
				
				setEquipSort(itemData)
				
				local subCategoryName, iconFile = getSubCategoryData(itemData)
				itemData.categoryMode = subCategoryModes[subCategoryName]
				
				return true
			else
				return false
			end
		end
	end
end

local function getFilterTypeComparator()
	return function(itemData)
		if optFilterFunction then
			return setTypeByName[itemData.setName] and optFilterFunction(itemData)
		else
			return setTypeByName[itemData.setName]
		end
	end
end
 --helper comparators

function IJAGI_DoesNewItemMatchFilterType(itemData, currentFilter)
    if not currentFilter then return true end
	return itemData.setType == currentFilter
end

function IJAGI:RefreshCategorySetList()
    self.categorySetList:Clear()
	
	local comparator = GetSetCategoryDataFilterComparator()
	
	local bags = {BAG_BACKPACK, BAG_BANK, BAG_SUBSCRIBER_BANK}
	local filteredDataTable = SHARED_INVENTORY:GenerateFullSlotData(comparator, unpack(bags))
	
	
	table.sort(filteredDataTable, function(data1, data2)
		return ZO_TableOrderingFunction(data1, data2, "setName", DEFAULT_SORT_KEYS, ZO_SORT_ORDER_UP)
	end)
	
	TOTAL_SETS = 0
	local categoryForCount
    for i, itemData in ipairs(filteredDataTable) do
		if itemData.setName ~= categoryForCount then
			categoryForCount = itemData.setName
			TOTAL_SETS = TOTAL_SETS + 1
		end
	end
	
	table.sort(filteredDataTable, sortSetItems)
	
	local lastSubCategoryName
    local lastSetType
    for i, itemData in ipairs(filteredDataTable) do
		if itemData.setType ~= nil then
			local categoryName, iconFile = getSubCategoryData(itemData)
			local icon = iconFile or subCategoryIcons[categoryName]
			
			local hasAnyNewItems = SHARED_INVENTORY:AreAnyItemsNew(IJAGI_DoesNewItemMatchFilterType, itemData.setType, unpack(bags))
			local data = ZO_GamepadEntryData:New(categoryName, icon, nil, nil, hasAnyNewItems)			
			data:SetIconTintOnSelection(true)
			
			data.setType = itemData.setType
			
			if itemData.setType ~= lastSetType and itemData.setType > 3 then
				lastSetType = itemData.setType
				data.categoryMode = 0
				categoryName = "All"
				
				data:ClearIcons()
				data:AddIcon(subCategoryIcons[categoryName])
				data:SetText(categoryName)
				
				data:SetHeader(categoryNameBySetType[itemData.setType])
				self.categorySetList:AddEntry("ZO_GamepadItemEntryTemplateWithHeader", data)
			else
				--	sub category
				if categoryName ~= lastSubCategoryName then
					lastSubCategoryName = categoryName
					if itemData.setType <= 3 then
						data:ClearIcons()
						local categoryName = categoryNameBySetType[itemData.setType]
						data:AddIcon(mainCategoryIcons[categoryName])
						data:SetText(categoryNameBySetType[itemData.setType])
						data.categoryMode = 0
					else
						data.categoryMode = subCategoryModes[categoryName]
						data:SetText(categoryName)
					end
					self.categorySetList:AddEntry("ZO_GamepadItemEntryTemplate", data)
				end
			end
		end
	end
    self.categorySetList:Commit()
end

---------------
-- Item List --
---------------

local function MenuEntryTemplateEquality(left, right)
    return left.uniqueId == right.uniqueId
end

local function SetupItemList(list)
    list:AddDataTemplate("ZO_GamepadItemSubEntryTemplate", ZO_SharedGamepadEntry_OnSetup, ZO_GamepadMenuEntryTemplateParametricListFunction, MenuEntryTemplateEquality)
    list:AddDataTemplateWithHeader("ZO_GamepadItemSubEntryTemplate", ZO_SharedGamepadEntry_OnSetup, ZO_GamepadMenuEntryTemplateParametricListFunction, MenuEntryTemplateEquality, "ZO_GamepadMenuEntryHeaderTemplate")
end

function IJAGI:InitializeSetItemList()
    self.itemSetList = GAMEPAD_INVENTORY:AddList("Set Items", SetupItemList)

    self.itemSetList:SetOnSelectedDataChangedCallback(function(list, selectedData)
		cancelTooltipLoop()
        GAMEPAD_INVENTORY.currentlySelectedData = selectedData
        GAMEPAD_INVENTORY:UpdateItemLeftTooltip(selectedData)

        GAMEPAD_INVENTORY:SetSelectedInventoryData(selectedData)
        GAMEPAD_INVENTORY:PrepareNextClearNewStatus(selectedData)
		
        self.itemSetList:RefreshVisible()
		
        IJAGI:UpdateRightTooltip()
        GAMEPAD_INVENTORY:RefreshActiveKeybinds()
    end)
end

local SET_LIST_SORT_KEYS ={
	setName = { tiebreaker = "equipSort",},
	equipSort = { tiebreaker = "name", tieBreakerSortOrder = ZO_SORT_ORDER_DOWN, isNumeric = true },
	name = { tiebreaker = "uniqueId",  },
	uniqueId = { isId64 = true },
}

function IJAGI:RefreshSetItemList()
    self.itemSetList:Clear()
	TOTAL_SETS = 0
    if self.categorySetList:IsEmpty() then return end
    local targetCategoryData = self.categorySetList:GetTargetData()
    local categoryMode = targetCategoryData.categoryMode
	local categoryType = targetCategoryData.setType
	
	local comparator = GetSetItemDataFilterComparator(categoryMode, categoryType)
	local bags = {BAG_BACKPACK, BAG_BANK, BAG_SUBSCRIBER_BANK}
	local filteredDataTable = SHARED_INVENTORY:GenerateFullSlotData(comparator, unpack(bags))
	
	for _, itemData in pairs(filteredDataTable) do
		itemData.bestItemCategoryName = itemData.setName
	end
	
	table.sort(filteredDataTable, function(data1, data2)
		return ZO_TableOrderingFunction(data1, data2, "setName", SET_LIST_SORT_KEYS, ZO_SORT_ORDER_UP)
	end)

    local lastBestItemCategoryName
    for i, itemData in ipairs(filteredDataTable) do
	local bagId, slotIndex = itemData.bagId, itemData.slotIndex
        local entryData = ZO_GamepadEntryData:New(itemData.name, itemData.iconFile)
        entryData:InitializeInventoryVisualData(itemData)
		
		if itemData.bagId > 1 then
--			entryData:AddIcon(bankIcon, itemData.iconFile)
			entryData:AddIcon(bankIcon, bankIcon)
		end
		
        if itemData.bagId == BAG_WORN then
            entryData.isEquippedInAnotherCategory = true

            entryData.isHiddenByWardrobe = WouldEquipmentBeHidden(itemData.slotIndex or EQUIP_SLOT_NONE)
        else
            local slotIndex = FindActionSlotMatchingItem(itemData.bagId, itemData.slotIndex)
            entryData.isEquippedInCurrentCategory = slotIndex ~= nil
        end

        local remaining, duration
		do
            remaining, duration = GetItemCooldownInfo(itemData.bagId, itemData.slotIndex)

            ZO_InventorySlot_SetType(entryData, SLOT_TYPE_GAMEPAD_INVENTORY_ITEM)
        end
        if remaining > 0 and duration > 0 then
            entryData:SetCooldown(remaining, duration)
        end

        entryData:SetIgnoreTraitInformation(true)
		entryData.slotType = SLOT_TYPE_CRAFTING_COMPONENT
		
        if itemData.bestItemCategoryName ~= lastBestItemCategoryName then
            lastBestItemCategoryName = itemData.bestItemCategoryName

            entryData:SetHeader(lastBestItemCategoryName)
            self.itemSetList:AddEntry("ZO_GamepadItemSubEntryTemplateWithHeader", entryData)
			TOTAL_SETS = TOTAL_SETS + 1
        else
            self.itemSetList:AddEntry("ZO_GamepadItemSubEntryTemplate", entryData)
        end
    end

    self.itemSetList:Commit()
end

--[[
INVENTORY_FRAGMENT:RegisterCallback("StateChange", function(oldState, newState)
	if newState == SCENE_HIDDING then
	d( "StateChange")
		cancelTooltipLoop()
		GAMEPAD_INVENTORY:SwitchActiveList(INVENTORY_CATEGORY_LIST)
	end
end)
--]]
--------------
-- Keybinds --
--------------
function IJAGI:Select()
    GAMEPAD_INVENTORY:SwitchActiveList(SET_ITEM_LIST)
    PlaySound(SOUNDS.GAMEPAD_MENU_FORWARD)
end
function IJAGI:InitializeKeybindStrip()
    self.categorySetListKeybindStripDescriptor =
    {
        alignment = KEYBIND_STRIP_ALIGN_LEFT,
        {
            name = GetString(SI_GAMEPAD_SELECT_OPTION),
            keybind = "UI_SHORTCUT_PRIMARY",
            order = -500,
            callback = function() self:Select() end,
			visible = function() return not self.categorySetList:IsEmpty() and not GAMEPAD_INVENTORY.currentlySelectedData.isCurrencyEntry end,
        },
        {
            name = GetString(SI_GAMEPAD_INVENTORY_EQUIPPED_MORE_ACTIONS),
            keybind = "UI_SHORTCUT_TERTIARY",
            order = 1000,
            visible = function()
                return GAMEPAD_INVENTORY.selectedItemUniqueId ~= nil
            end,

            callback = function()
                GAMEPAD_INVENTORY:ShowActions()
            end,
        },
        { 
            name = GetString(SI_ITEM_ACTION_STACK_ALL),
            keybind = "UI_SHORTCUT_LEFT_STICK",
            order = 1500,
            disabledDuringSceneHiding = true,
            callback = function()
                StackBag(BAG_BACKPACK)
            end,
        },
        { 
            name = GetString(SI_ITEM_ACTION_STOW_MATERIALS),
            keybind = "UI_SHORTCUT_RIGHT_STICK",
            order = 2000,
            disabledDuringSceneHiding = true,
            visible = function()
                          return IsESOPlusSubscriber() and CanAnyItemsBeStoredInCraftBag(BAG_BACKPACK)
                      end,
            callback = function()
                ZO_Inventory_TryStowAllMaterials()
            end,
        },
    }

    ZO_Gamepad_AddBackNavigationKeybindDescriptors(self.categorySetListKeybindStripDescriptor, GAME_NAVIGATION_TYPE_BUTTON)

    self.toggleCompareModeKeybindStripDescriptor =
    {
		alignment = KEYBIND_STRIP_ALIGN_RIGHT,
		name = GetString(SI_GAMEPAD_INVENTORY_TOGGLE_ITEM_COMPARE_MODE),
		keybind = "UI_SHORTCUT_SECONDARY",
		visible = function() return true end,
		callback = function()
			GAMEPAD_INVENTORY.savedVars.useStatComparisonTooltip = not GAMEPAD_INVENTORY.savedVars.useStatComparisonTooltip
			GAMEPAD_INVENTORY.currentlySelectedData = IJAGI.itemSetList:GetSelectedData()
			IJAGI:UpdateRightTooltip()
		end,
		
    }

end

ZO_PreHook(GAMEPAD_INVENTORY, "InitializeKeybindStrip", function(self)
    self.setItemFilterKeybindStripDescriptor =
    {
        alignment = KEYBIND_STRIP_ALIGN_LEFT,
        {
            name = GetString(SI_GAMEPAD_SELECT_OPTION),
            keybind = "UI_SHORTCUT_PRIMARY",
            order = -500,
			callback = function() d( "This should not show") end,
            visible = function() return true end,
			enabled = function() return false end,

        },
        {
            name = GetString(SI_GAMEPAD_INVENTORY_ACTION_LIST_KEYBIND),
            keybind = "UI_SHORTCUT_TERTIARY",
            order = 1000,
            visible = function()
                return self.selectedItemUniqueId ~= nil
            end,

            callback = function()
                self:ShowActions()
            end,
        },
        {
            name = GetString(SI_ITEM_ACTION_STACK_ALL),
            keybind = "UI_SHORTCUT_LEFT_STICK",
            order = 1500,
            disabledDuringSceneHiding = true,
            callback = function()
                StackBag(BAG_BACKPACK)
            end,
        },
        {
            name = GetString(SI_ITEM_ACTION_DESTROY),
            keybind = "UI_SHORTCUT_RIGHT_STICK",
            order = 2000,
            disabledDuringSceneHiding = true,

            visible = function()
				return false
--				local targetData = IJAGI.itemSetList:GetTargetData()
--				return self.selectedItemUniqueId ~= nil and targetData ~= nil and ZO_InventorySlot_CanDestroyItem(targetData)
            end,

            callback = function()
                local targetData = IJAGI.itemSetList:GetTargetData()
                if ZO_InventorySlot_CanDestroyItem(targetData) and ZO_InventorySlot_InitiateDestroyItem(targetData) then
                    IJAGI.itemSetList:Deactivate()
                    self.listWaitingOnDestroyRequest = IJAGI.itemSetList
                end
            end
        }
    }
	
    local function ItemListBackFunction()
        self:SwitchActiveList(SET_CATEGORY_LIST)
        PlaySound(SOUNDS.GAMEPAD_MENU_BACK)
    end
    ZO_Gamepad_AddBackNavigationKeybindDescriptors(self.setItemFilterKeybindStripDescriptor, GAME_NAVIGATION_TYPE_BUTTON, ItemListBackFunction)
	return false
end)

-------------------------------------
-- Gamepad Merchant Inventory List
-------------------------------------
local gamePadSellModeList = STORE_WINDOW_GAMEPAD.components[ZO_MODE_STORE_SELL].list

ZO_PostHook(gamePadSellModeList, "UpdateList", function(self)
	self:Clear()
    local items = self.updateFunc()
	table.sort(items, SellSortFunc)
    self:AddItems(items)
end)


-------------------------------------
-- Gamepad Bank Inventory Sort
-------------------------------------

--	Changes the bank withdraw and deposit lists sort order for junk items
ZO_PreHook(GAMEPAD_BANKING, "OnCategoryChangedCallback", function(self, selectedData)
	self.withdrawList:SetSortFunction(sortJunkToTOP)
	self.depositList:SetSortFunction(sortJunkToBottom)
	return false
end)

-- 	needing to clear the bank inventory list due to it not updating if an item is un/marked as junk
--	after the bank lists has been loaded previously
EVENT_MANAGER:RegisterForEvent("IJAGI_On_Open_Bank", EVENT_OPEN_BANK, function()
	if GAMEPAD_BANKING.initialized then
	GAMEPAD_BANKING.withdrawList:RefreshList()
	GAMEPAD_BANKING.depositList:RefreshList()
	end
	return false
end)

-------------------------------------
-- Gamepad Guild Bank Deposit Sort
-------------------------------------

--	Changes the guild bank deposit lists sort order for junk items
ZO_PreHook(GAMEPAD_GUILD_BANK, "RefreshGuildBank", function(self)
	self.depositList:SetSortFunction(sortJunkToBottom)
	return true
end)

EVENT_MANAGER:RegisterForEvent("IJAGI_On_Close_GuildBank", EVENT_CLOSE_GUILD_BANK, function()
	GAMEPAD_INVENTORY:SetCurrentList(GAMEPAD_INVENTORY.categoryList)
end)
--	/script d(GAMEPAD_INVENTORY:GetCurrentList())
-- GAMEPAD_INVENTORY:SetCurrentList(GAMEPAD_INVENTORY.categoryList)
-------------------------------------
-- Gamepad Smithing Deconstruct
-------------------------------------
local function useCarriedTab()
						-- not in use
	local function isDeconInBackpack()
		local bagsToUse = useWornBag and ZO_ALL_CRAFTING_INVENTORY_BAGS_AND_WORN or ZO_ALL_CRAFTING_INVENTORY_BAGS_WITHOUT_WORN
		local list = SHARED_INVENTORY:GenerateFullSlotData(ZO_SharedSmithingExtraction_IsExtractableItem, BAG_BACKPACK)
		
		for i, slotData in ipairs(list) do
			local bagId = slotData.bagId
			if bagId == BAG_BACKPACK then
				return true
			end
		end
	end

	local function convertToFilter()
		local crftingInteractionType = GetCraftingInteractionType()
		if crftingInteractionType == 2 then
			return 4
		elseif crftingInteractionType == 7 then
			return 6
		else
			return 2
		end
	end

	ZO_PreHook(ZO_GamepadSmithingExtraction, "UpdateEmptySlotIcon", function(self)
--	function ZO_GamepadSmithingExtraction:UpdateEmptySlotIcon()
		if addOnName ~= IJAGI.name then
			return false
		end
		local filterType = self:GetFilterType()
		if filterType then
			if filterType == SMITHING_FILTER_TYPE_MAX_VALUE then
				self.extractionSlot:SetEmptyTexture(ZO_GamepadCraftingUtils_GetItemSlotTextureFromSmithingFilter(convertToFilter()))
			else
				self.extractionSlot:SetEmptyTexture(ZO_GamepadCraftingUtils_GetItemSlotTextureFromSmithingFilter(filterType))
			end
		end
		local deconstructionType = self:GetDeconstructionType()
		if deconstructionType then
			self.extractionSlot:SetMultipleItemsTexture(ZO_GamepadCraftingUtils_GetMultipleItemsTextureFromSmithingDeconstructionType(deconstructionType))
		end
		
		-- reanchor slot icon based on special refine "you need 10 of this" text
		local slotBG = self.extractionSlot.control:GetNamedChild("Bg")
		local emptySlotIconControl = self.extractionSlot.control:GetNamedChild("EmptySlotIcon")
		emptySlotIconControl:ClearAnchors()
		if filterType == SMITHING_FILTER_TYPE_RAW_MATERIALS then
			emptySlotIconControl:SetAnchor(TOP, slotBG, TOP, 0, 10)
		else
			emptySlotIconControl:SetAnchor(CENTER, slotBG)
		end
		return true
	end)
	
	ZO_PostHook(ZO_GamepadSmithingExtraction, "SetCraftingType", function(self)
		local sceneDecon = SCENE_MANAGER:GetScene("gamepad_smithing_deconstruct")
		local sceneRefine = SCENE_MANAGER:GetScene("gamepad_smithing_refine")
		local function AddTabEntry(tabBarEntries, filterType)
			if ZO_CraftingUtils_CanSmithingFilterBeCraftedHere(filterType) or filterType == SMITHING_FILTER_TYPE_MAX_VALUE then
				local entry = {}
				if filterType == SMITHING_FILTER_TYPE_MAX_VALUE then
					entry.text = GetString(SI_IJAGI_CARRIED)
				else
					entry.text = GetString("SI_SMITHINGFILTERTYPE", filterType)
				end
				entry.callback = function()
					if not ZO_CraftingUtils_IsPerformingCraftProcess() then
						self:SetFilterType(filterType)
					end
				end
				entry.filterType = filterType
				table.insert(tabBarEntries, entry)
			end
		end
		local function tabBarCallback(oldState, newState)
			if newState == SCENE_SHOWING then
				local refinementOnly = false
				if SMITHING_GAMEPAD.mode == SMITHING_MODE_REFINEMENT then refinementOnly = true end
				if refinementOnly then
					self:SetFilterType(SMITHING_FILTER_TYPE_RAW_MATERIALS)
				else
					self:SetFilterType(SMITHING_FILTER_TYPE_WEAPONS)
				end
		
				ZO_GamepadGenericHeader_Deactivate(self.owner)
	--			scene:UnregisterCallback("StateChange", tabBarCallback)
				local tabBarEntries = {}
				if not refinementOnly then
					AddTabEntry(tabBarEntries, SMITHING_FILTER_TYPE_MAX_VALUE)
--					if isDeconInBackpack() then AddTabEntry(tabBarEntries, SMITHING_FILTER_TYPE_MAX_VALUE) end
					AddTabEntry(tabBarEntries, SMITHING_FILTER_TYPE_WEAPONS)
					AddTabEntry(tabBarEntries, SMITHING_FILTER_TYPE_ARMOR)
					AddTabEntry(tabBarEntries, SMITHING_FILTER_TYPE_JEWELRY)
					
					local titleString = ZO_GamepadCraftingUtils_GetLineNameForCraftingType(GetCraftingInteractionType())
					ZO_GamepadCraftingUtils_SetupGenericHeader(self.owner, titleString, tabBarEntries)
					if #tabBarEntries > 1 then
						ZO_GamepadGenericHeader_Activate(self.owner.header)
					end
				else
					local titleString = GetString(SI_SMITHING_TAB_REFINEMENT)
					ZO_GamepadCraftingUtils_SetupGenericHeader(self.owner, titleString)
				end
				
				ZO_GamepadCraftingUtils_RefreshGenericHeader(self.owner)
				-- tab bar / screen state fight with each other when switching between apparel only / other stations when sharing a tab bar...kick apparel station to the right filterType
				if #tabBarEntries == 1 then
					self:SetFilterType(tabBarEntries[1].filterType)
				end
				self:RemoveItemFromCraft()
				self.inventory:HandleDirtyEvent()
			end
			

			sceneDecon:UnregisterCallback("StateChange", tabBarCallback)
			sceneRefine:UnregisterCallback("StateChange", tabBarCallback)
		end
		
		sceneDecon:RegisterCallback("StateChange", tabBarCallback)
		sceneRefine:RegisterCallback("StateChange", tabBarCallback)
	end)
	
	function ZO_SharedSmithingExtraction_DoesItemPassFilter(bagId, slotIndex, filterType)
		if addOnName ~= IJAGI.name then
			d( "|cFF00FF" .. "IsJusta Gamepad Inventory Update" .. "|r is using this function.")
			return false
		end
		if filterType == SMITHING_FILTER_TYPE_RAW_MATERIALS then
			if IJAGI.savedVariables.cleanRefinementTab then
				local stack, maxStack = GetSlotStackSize(bagId, slotIndex)
				if stack < GetRequiredSmithingRefinementStackSize() then return end
			end
			return ZO_CraftingUtils_GetSmithingFilterFromItem(bagId, slotIndex) == filterType
		else
			if bagId == BAG_BACKPACK then
				if filterType == SMITHING_FILTER_TYPE_MAX_VALUE then
					return true
				end
			else
				return ZO_CraftingUtils_GetSmithingFilterFromItem(bagId, slotIndex) == filterType
			end
		end
	end
end

-------------------------------------
-- Add Mark/Unmark as Junk to Inventory Item Action list
-------------------------------------
local function MarkAsJunkHelper(bag, index, isJunk)
	SetItemIsJunk(bag, index, isJunk)
	PlaySound(isJunk and SOUNDS.INVENTORY_ITEM_JUNKED or SOUNDS.INVENTORY_ITEM_UNJUNKED)
end
local function AddItem(inventorySlot, slotActions)
	local valid = ZO_Inventory_GetBagAndIndex(inventorySlot)
	if not valid or inventorySlot.stolen then return end
	if SCENE_MANAGER:IsShowing("gamepad_inventory_root") or SCENE_MANAGER:IsSceneOnStack("gamepad_inventory_root") then
		local bag, index = ZO_Inventory_GetBagAndIndex(inventorySlot)
		if not IsItemPlayerLocked(bag, index) and CanItemBeMarkedAsJunk(bag, index) and not IsItemJunk(bag, index) and not QUICKSLOT_WINDOW:AreQuickSlotsShowing() and IsInGamepadPreferredMode() then
			slotActions:AddCustomSlotAction(SI_ITEM_ACTION_MARK_AS_JUNK, function() MarkAsJunkHelper(bag, index, true) end, "")
		end
		if not IsItemPlayerLocked(bag, index) and CanItemBeMarkedAsJunk(bag, index) and IsItemJunk(bag, index) and not QUICKSLOT_WINDOW:AreQuickSlotsShowing() and IsInGamepadPreferredMode() then
			slotActions:AddCustomSlotAction(SI_ITEM_ACTION_UNMARK_AS_JUNK, function() MarkAsJunkHelper(bag, index, false) end, "")
		end
	end
end
local menu = LibCustomMenu
local function OnPlayerActivated()
	menu:RegisterKeyStripEnter(AddItem, menu.CATEGORY_PRIMARY)
	EVENT_MANAGER:UnregisterForEvent("IsJustaGamepadInventory", EVENT_PLAYER_ACTIVATED)
end

-------------------------------------
function IJAGI:Setup()
	EVENT_MANAGER:RegisterForEvent("IsJustaGamepadInventory", EVENT_PLAYER_ACTIVATED, OnPlayerActivated)
	
	IJAGI:SetupSettings()
	
	if self.savedVariables.useCarriedTab then useCarriedTab() end
end

function IJAGI.OnLoad(eventCode, addOnName)
	if addOnName ~= IJAGI.name then
		return
	end
	
	local AccountWideSavedVars = ZO_SavedVars:NewAccountWide("IJAGI_Beta_SavedVars", IJAGI.svVersion, nil, IJAGI.defaults)
	IJAGI.savedVariables = AccountWideSavedVars
	
	EVENT_MANAGER:UnregisterForEvent("IsJustaGamepadInventory", EVENT_ADD_ON_LOADED)

	IJAGI:Setup()
end

EVENT_MANAGER:RegisterForEvent("IsJustaGamepadInventory", EVENT_ADD_ON_LOADED, IJAGI.OnLoad)